/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ist.palcom.assemblies;

import ist.palcom.debugging.DebugDispatcher;
import ist.palcom.device.DeviceContext;
import ist.palcom.discovery.CommandEvent;
import ist.palcom.discovery.InfoEvent;
import ist.palcom.palcomthreads.Event;
import ist.palcom.palcomthreads.PalcomPriorityThread;
import ist.palcom.resource.descriptor.PRDAssemblyVer;
import ist.palcom.resource.descriptor.Command;
import ist.palcom.resource.descriptor.PRDConnection;
import ist.palcom.resource.descriptor.URN;

/**
 * A class for handling the communication of updates between two 
 * AssemblyManagers.
 * 
 * @author sven
 *
 */
public class UpdateThread extends PalcomPriorityThread {
	private UpdateStateMachine updateStateMachine;
	private DeviceContext deviceContext;
	private URN providerURN;
	private URN customerURN;
	private boolean cont;
	
	
	public UpdateThread(UpdateStateMachine usm, DeviceContext dc, URN prov, URN cust) {
		updateStateMachine = usm;
		deviceContext = dc;
		providerURN = prov;
		customerURN = cust;
	}
	
	public void run() {
		cont = true;
		while(cont) {
			Event e = waitEvent();
//			System.out.println("UT: got Event:"+e.getClass());
			handleEvent(e);
		}
	}
	
	public void handleEvent(Object o) {
		throw new Error("UpdateThread.handleEvent broken by URN refactoring");
//		if(o instanceof CommandEvent) {
//			Command c = ((CommandEvent)o).getCommand();
//			if(c.getID().equals(IAssemblyManager.COMMAND_UPDATE)) {
////				System.out.println("UT: Assembly Update Command");
//				byte[] xmlData = c.getParam(0).getData();
//				PRDAssembly ai = UpdateStateMachine.parseAssemblyXML(xmlData);				
//				updateStateMachine.doCheckUpdate(ai,((CommandEvent)o).getSource());
//			}
//		} else if(o instanceof InfoEvent) { 			
//				boolean a = ((InfoEvent)o).getInfo() instanceof PRDConnection;
//				boolean b = !((InfoEvent)o).infoShouldBeKept();
//				boolean c = ((PRDConnection)((InfoEvent)o).getInfo()).getProviderURN().equals(providerURN);
//				boolean d = ((PRDConnection)((InfoEvent)o).getInfo()).getCustomerURN().equals(customerURN);
//				if(a && b && c && d){
//					DebugDispatcher.debug("UpdateThread: got disconnected", DebugDispatcher.CAT_UPDATE);
//					updateStateMachine.allowURN(providerURN.getDeviceURN());
//					deviceContext.getResourceManager2().removePRDConnectionReceiver(providerURN.getDeviceURN().toString(), this);
//					deviceContext.getResourceManager2().removePRDConnectionReceiver(customerURN.getDeviceURN().toString(), this);
//					cont = false;
//				}
//		}
	}
//	private void doCheckUpdate(AssemblyInfo ai, Object src) {
//		Assembly tmp = deviceContext.getAssemblyManager().checkIfUpdate(ai);
//		if(tmp != null) {
//			//TODO: actually do something here.
//			System.out.println("Received update for "+tmp.assemblyInfo.getName()+" : "+tmp.assemblyInfo.getLogicalVersion() + "("+ai.getLogicalVersion()+")");
//			if(src instanceof ServiceProxy) {
//				ServiceProxy sp = (ServiceProxy)src;
//				System.out.println("   from "+sp.getURN());
//			}
//		}
//	}
}
