package ist.palcom.assembly.manager;

import java.util.Iterator;

import ist.palcom.assemblies.Assembly;
import ist.palcom.palcomthreads.PalcomThread;
import ist.palcom.resource.descriptor.ConnectionDecl;
import ist.palcom.resource.descriptor.ConnectionInfo;
import ist.palcom.resource.descriptor.Info;
import ist.palcom.resourceAddressing.AInfoEvent;

/** 
 * Class representing a connection request 
 */
abstract class ConnectionRequest {
	/**
	 * 
	 */
	private ConnectionDecl cd;
	private Assembly assembly;
	private PalcomThread recv;
	
	ConnectionRequest(ConnectionDecl cd, Assembly assembly, PalcomThread recv) {
		this.cd = cd;
		this.assembly = assembly;
		this.recv = recv;
	}
	public abstract void satisfied(ConnectionInfo i);
	
	public abstract boolean isSatisfied();
	
	public abstract void unsatisfied();
			
	public abstract boolean isActiveConnection(ConnectionInfo info);
	
	ConnectionDecl getDeclaration() {
		return cd;
	}
	
	Assembly getAssembly() {
		return assembly;
	}
	
	PalcomThread getReceiver() {
		return recv;
	}

	/**
	 * Checks if a connection request is possible
	 * 
	 * @param ie - the InfoEvent to check against
	 */

	public abstract ConnectionInfo checkAgainstServices(Iterator i);
	
	public abstract boolean isAlternative();
	
	public String toString() {
		return this.getClass().toString() + ":"+getDeclaration().toString();
	}
	public abstract boolean checkIfPossible();
	public void checkSoftwareManagers(Iterator iterator) {
		
	}
}