package ist.palcom.hgraph.manager;

import ist.palcom.hgraph.AbstractInvokator;
import ist.palcom.hgraph.NodeHandler;
import ist.palcom.hgraph.Path;
import ist.palcom.hgraph.PrintHandler;
import ist.palcom.hgraph.Signature;
import ist.palcom.hgraph.Value;

/**
 * Invokator for invoking commands across the H-Graph. All return events are aimed at hitting the HgraphManagerReturnHandler
 *
 */
public class HgraphManagerInvokator extends AbstractInvokator{

	private static final String name = "Hgraph Manager Invokator";
	private static final String description = "Invokator for invoking commands across the H-Graph.\n"+
											   "All return events are aimed at hitting the HgraphManagerReturnHandler";

	public HgraphManagerInvokator(HgraphManager node) {
		super(node, name, description);
	}

	public void invokeHasChild(Path p){
		invoke(NodeHandler.CMD_HASCHILD, p, HgraphManagerReturnHandler.CMD_RETURN_CD, null);
	}
	public void invokePrint(Path p){
		invoke(PrintHandler.CMD_PRINT, p, HgraphManagerReturnHandler.CMD_RETURN_DIR, null);				
	}
	public void invokePrintFull(Path p){
		invoke(PrintHandler.CMD_PRINT_FULL, p, HgraphManagerReturnHandler.CMD_RETURN_DIR, null);				
	}
	public void invokePrintFullRecursively(Path p){
		invoke(PrintHandler.CMD_PRINT_RECURSIVELY, p, HgraphManagerReturnHandler.CMD_RETURN_DIR, null);
	}
	public void invokeNewChild(Path p, Value name){
		invoke(NodeHandler.CMD_NEWCHILD, p, HgraphManagerReturnHandler.CMD_RETURN_NEWNODE, name);						
	}
	public void invokeRemoveChild(Path p, Value name){
		invoke(NodeHandler.CMD_REMOVECHILD, p, HgraphManagerReturnHandler.CMD_RETURN_REMOVENODE, name);						
	}
	public void invokeSetName(Path p, Value name){
		invoke(NodeHandler.CMD_SETNAME, p, HgraphManagerReturnHandler.CMD_RETURN_SETNAME, name);						
	}
}
