/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

//package ist.palcom.mal.udp.test;
//
//import ist.palcom.resource.descriptor.Selector;
//import ist.palcom.resource.descriptor.URL;
//import ist.palcom.resource.descriptor.URN;
//import ist.palcom.mal.CompoundMediaManager;
//import ist.palcom.mal.MediaManager;
//import ist.palcom.mal.Message;
//import ist.palcom.mal.MessageEvent;
//import ist.palcom.mal.SimpleMessage;
//import ist.palcom.mal.udp.UDPMediaManager;
//import ist.palcom.palcomthreads.PalcomPriorityThread;
//import ist.palcom.palcomthreads.PalcomScheduler;
//import ist.palcom.palcomthreads.PalcomThread;
//
///**
// * @author David Svensson, david@cs.lth.se
// */
//public class UDPCommunicationTest {
//
//    public static void main(String[] args) {
//        UDPCommunicationTest test = new UDPCommunicationTest();
//
//        test.testCreateMessage();
//        System.out.println();
//        test.testSendAndReceiveMessage();
//        System.out.println();
//        test.testMulticast();
//        System.out.println();
//        test.testCompoundMediaManager();
//        System.out.println();
//        test.testSendAndReceiveMessageWithURNs();
//        System.out.println();
//        test.testBroadcastWithURN();
//        System.out.println();
//        test.testUnicastWithURNAfterBroadcast();
//        System.out.println();
//    }
//
//    private void testCreateMessage() {
//        System.out.println("--- testCreateMessage ---");
//
//        byte[] data = "Message data".getBytes();
//        System.out.println("Message data created with length " + data.length);
//        Message message = new SimpleMessage(data, 0, data.length);
//
//        byte[] result = new byte[message.getTotalLength()];
//        System.out.println("Length of result " + result.length);
//        message.write(result, 0);
//        for (int i = 0; i < result.length; i++) {
//            System.out.print((char) result[i]);
//        }
//        System.out.println();
//    }
//
//    private void testSendAndReceiveMessage() {
//        System.out.println("--- testSendAndReceiveMessage ---");
//
//        final PalcomScheduler scheduler = new PalcomScheduler();
//        PalcomThread t = new PalcomPriorityThread() {
//            public void run() {
//                MediaManager manager = new UDPMediaManager(scheduler, null);
//
//                URL receiverURL = manager.startReceiving(this);
//
//                byte[] sentData = "Some data".getBytes();
//                Message message = new SimpleMessage(sentData, 0,
//                        sentData.length);
//
//                System.out.println("Sending message of total length "
//                        + message.getTotalLength() + " (selector not set)");
//
//                manager.send(message, receiverURL);
//
//                waitForMessageAndPrintIt(this);
//
//                manager.stop();
//            }
//        };
//        scheduler.scheduleThread(t);
//        scheduler.run();
//    }
//
//    private void testMulticast() {
//        System.out.println("--- testMulticast ---");
//
//        final PalcomScheduler scheduler = new PalcomScheduler();
//        PalcomThread t = new PalcomPriorityThread() {
//            public void run() {
//                MediaManager mediaManager = new UDPMediaManager(scheduler, null);
//
//                testSendAndReceiveMulticastMessage(scheduler, mediaManager,
//                        this, new URL("palcom:datagram://224.12.13.14:4099"),
//                        "Multi-cast message 1");
//
//                mediaManager.stop();
//            }
//        };
//        scheduler.scheduleThread(t);
//        scheduler.run();
//    }
//
//    private void testCompoundMediaManager() {
//        System.out.println("--- testCompoundMediaManager ---");
//
//        final PalcomScheduler scheduler = new PalcomScheduler();
//        PalcomThread t = new PalcomPriorityThread() {
//            public void run() {
//                MediaManager udpManager = new UDPMediaManager(scheduler, null);
//                CompoundMediaManager compoundManager = new CompoundMediaManager(
//                        scheduler, "datagram", udpManager, null);
//
//                // Try sending and receiving a message using the compound
//                // manager
//                URL receiverURL = compoundManager.startReceiving(this);
//                byte[] sentData = "Message data".getBytes();
//                Message message = new SimpleMessage(sentData, 0,
//                        sentData.length);
//                compoundManager.send(message, receiverURL);
//                waitForMessageAndPrintIt(this);
//
//                compoundManager.stop();
//            }
//        };
//        scheduler.scheduleThread(t);
//        scheduler.run();
//    }
//
//    private void testSendAndReceiveMulticastMessage(PalcomScheduler scheduler,
//            MediaManager manager, PalcomThread receiver, URL mcAddress,
//            String data) {
//        byte[] dataBytes = data.getBytes();
//        Message message = new SimpleMessage(dataBytes, 0, dataBytes.length);
//        URL returnedAddress = manager.startReceiving(mcAddress, receiver);
//        manager.send(message, returnedAddress);
//        System.out.println("Message sent");
//        waitForMessageAndPrintIt(receiver);
//    }
//
//    private void testSendAndReceiveMessageWithURNs() {
//        System.out.println("--- testSendAndReceiveMessageWithURNs ---");
//
//        final PalcomScheduler scheduler = new PalcomScheduler();
//        PalcomThread t = new PalcomPriorityThread() {
//            public void run() {
//                MediaManager manager = new UDPMediaManager(scheduler, null);
//
//                Selector receiverSelector = manager.startReceiving2(this);
//                Selector senderSelector = manager.startReceiving2(this);
//                // Sender also starts to listen, so a selector is allocated
//
//                byte[] sentData = "Some data".getBytes();
//                Message message = new SimpleMessage(sentData, 0,
//                        sentData.length);
//
//                System.out.println("Sending message of total length "
//                        + message.getTotalLength()
//                        + " (URNs and selectors not set)");
//
//                final URN senderURN = new URN("urn:palcom://sender");
//                final URN receiverURN = new URN("urn:palcom://receiver");
//
//                // Manually register device URL, so the manager knows about the
//                // receiver. In real use, this information is spread via
//                // broadcast messages
//                manager.registerDeviceURL(receiverURN, manager
//                        .getDefaultUnicastURL());
//
//                manager.send(message, senderURN, senderSelector, receiverURN,
//                        receiverSelector);
//
//                waitForMessageAndPrintIt(this);
//
//                manager.stop();
//            }
//        };
//        scheduler.scheduleThread(t);
//        scheduler.run();
//    }
//
//    private void testBroadcastWithURN() {
//        System.out.println("--- testBroadcastWithURN ---");
//
//        final PalcomScheduler scheduler = new PalcomScheduler();
//        PalcomThread t = new PalcomPriorityThread() {
//            public void run() {
//                MediaManager manager = new UDPMediaManager(scheduler, null);
//
//                Selector senderSelector = manager.startReceiving2(this);
//                testSendAndReceiveBroadcastMessage(scheduler, manager, this,
//                        new URN("urn:palcom://sender"), senderSelector,
//                        "Broadcast message");
//
//                manager.stop();
//            }
//        };
//        scheduler.scheduleThread(t);
//        scheduler.run();
//    }
//
//    private void testUnicastWithURNAfterBroadcast() {
//        System.out.println("--- testUnicastWithURNAfterBroadcast ---");
//
//        final PalcomScheduler scheduler = new PalcomScheduler();
//        PalcomThread t = new PalcomPriorityThread() {
//            public void run() {
//                MediaManager manager = new UDPMediaManager(scheduler, null);
//
//                final URN senderURN = new URN("urn:palcom://sender");
//                final URN receiverURN = new URN("urn:palcom://receiver");
//
//                Selector receiverSelector = manager.startReceiving2(this);
//                Selector senderSelector = manager.startReceiving2(this);
//                // Sender also starts to listen, so a selector is allocated
//
//                // First, we let the receiver send out a broadcast message
//                testSendAndReceiveBroadcastMessage(scheduler, manager, this,
//                        receiverURN, receiverSelector, "Broadcast data");
//
//                // No manual registration of URNs needed after the broadcast.
//                // The information about the receiver device has now reached the
//                // sender.
//
//                byte[] sentData = "Unicast data".getBytes();
//                Message message = new SimpleMessage(sentData, 0,
//                        sentData.length);
//                manager.send(message, senderURN, senderSelector, receiverURN,
//                        receiverSelector);
//                waitForMessageAndPrintIt(this);
//
//                manager.stop();
//            }
//        };
//        scheduler.scheduleThread(t);
//        scheduler.run();
//    }
//
//    private void testSendAndReceiveBroadcastMessage(PalcomScheduler scheduler,
//            MediaManager manager, PalcomThread receiver, URN senderURN,
//            Selector senderSelector, String data) {
//        byte[] dataBytes = data.getBytes();
//        Message message = new SimpleMessage(dataBytes, 0, dataBytes.length);
//        manager.startReceivingBroadcast(receiver);
//        manager.sendBroadcast(message, senderURN, senderSelector);
//        System.out.println("Broadcast message sent");
//        waitForMessageAndPrintIt(receiver);
//    }
//
//    public static void waitForMessageAndPrintIt(PalcomThread receiver) {
//        MessageEvent event = (MessageEvent) receiver.waitEvent();
//        Message m = event.getMessage();
//        System.out.println("Message received");
//        System.out.println("  Total length " + m.getTotalLength());
//        byte[] receivedData = new byte[m.getTotalLength()];
//        m.write(receivedData, 0);
//        System.out.print("  Data: ");
//        System.out.println(new String(receivedData));
//    }
//}
