/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


// Generated with JastAdd II (http://jastadd.cs.lth.se) version R20070924

public class ASTNode implements Cloneable {
    public void flushCache() {
        getParentPRDAssemblyVer_visited = false;
        getErrorList_visited = false;
        getBrowserLabel_visited = false;
        getAssemblyLabel_visited = false;
        prettyPrintChildren_visited = false;
        getPrettyString_visited = false;
        getPrettyClosingString_visited = false;
        encloseInBraces_visited = false;
        getIndent_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ASTNode node = (ASTNode)super.clone();
        node.getParentPRDAssemblyVer_visited = false;
        node.getErrorList_visited = false;
        node.getBrowserLabel_visited = false;
        node.getAssemblyLabel_visited = false;
        node.prettyPrintChildren_visited = false;
        node.getPrettyString_visited = false;
        node.getPrettyClosingString_visited = false;
        node.encloseInBraces_visited = false;
        node.getIndent_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ASTNode node = (ASTNode)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ASTNode res = (ASTNode)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyNameEditing.jadd at line 49

	
	/** get the ID (name, etc) of the attribute or child to be edited
	 *  when selecting the node.
	 */
	public String getIDforEditing() {
		DebugDispatcher.debug("ASTNode.getIDforEditing():"+this, DebugDispatcher.CAT_EDITOR);
		return null;
	}

    // Declared in AssemblyNameEditing.jadd at line 86



	/** Set the new name (ID, etc). 
	 * @return true if the tree was actually changed.
	 */
	public boolean updateIDfromEditor(String id) {
		DebugDispatcher.debug("ASTNode.updateIDfromEditor:"+this, DebugDispatcher.CAT_EDITOR);
		return false;
	}

    // Declared in DeviceTree.jadd at line 193

	
/** Helper method for the TreeView 
 *
 * @return The (interesting) children of a node, as an Object array
 * possibly bypassing levels in the tree or ignoring certain children.
 */

	public Object[] getChildArray() {
		int nc = getNumChild();
		if(nc > 0) {
			Object tmp[] = new Object[nc];
			for(int i=0; i<nc; i++) {
				tmp[i] = getChild(i);
			}
			return tmp;
		} else {
			return null;
		}
	}

    // Declared in ErrorChecking.jrag at line 201

	
	/** 
	 * Hack to add a whole (sub)tree to an ArrayList
	 */
	public void addASTtoList(ArrayList l) {
		l.add(l.size(),this);
		for(int i=0; i<getNumChild();i++) {
			getChild(i).addASTtoList(l);
		}
	}

    // Declared in PrettyPrint.jrag at line 40

 
   public void prettyprint(PrintStream s) {
      pp(s, "");
   }

    // Declared in PrettyPrint.jrag at line 82

   
   void pp(PrintStream ppStream, String indent) {
	   if(getPrettyString().length() > 0) {
		   ppStream.print(indent+getPrettyString());
		   if(encloseInBraces()) ppStream.print(" {");
		   ppStream.println();
	   }
	   if(prettyPrintChildren()) {
		   for(int i=0; i < getNumChild(); i++) {
			   getChild(i).pp(ppStream, indent+getIndent());
		   }
	   }
	   if(encloseInBraces()) 
		   ppStream.println(indent+"}");
   }

    // Declared in ResetTree.jadd at line 37

	public void resetTree() {
		for(int i = 0; i < getNumChild(); i++) {
			if(getChild(i) != null) getChild(i).resetTree();
		}
		flushCache();
		/*if(getParent() != null) 
			isFinal = false;
		inRewrite = false;
		*/
	}

    // Declared in Removal.jadd at line 37

    public void removeChild(int i) {
        if(children != null && children.length > i) {
            ASTNode node = children[i];
            ASTNode c[] = new ASTNode[children.length - 1];
            if (i > 0) {
                System.arraycopy(children, 0, c, 0, i);
            }
            System.arraycopy(children, i+1, c, i, c.length-i);
            children = c;
            numChildren--;
            if (node != null) {
                node.childIndex = -1;
            }
			if(numChildren==0){
            	children=null;
            }
        }
    }

    // Declared in Removal.jadd at line 56


    public boolean remove() {
        ASTNode p = getParent();
        if(p != null) {
            int idx = p.getIndexOfChild(this);
            if(idx >= 0) {
                parent.removeChild(idx);
                return true;
            }
        }
        return false;
    }

    // Declared in null at line 3
    // Declared in null line 0

    public ASTNode() {
        super();


    }

    // Declared in null at line 9


   static public boolean generatedWithCircularEnabled = true;

    // Declared in null at line 10

   static public boolean generatedWithCacheCycle = true;

    // Declared in null at line 11

   static public boolean generatedWithComponentCheck = false;

    // Declared in null at line 12

  static public boolean IN_CIRCLE = false;

    // Declared in null at line 13

  static public boolean CHANGE = false;

    // Declared in null at line 14

  static public boolean LAST_CYCLE = false;

    // Declared in null at line 15

  static public boolean RESET_CYCLE = false;

    // Declared in null at line 16

  public ASTNode getChild(int i) {
    return getChildNoTransform(i);
  }

    // Declared in null at line 19

  private int childIndex;

    // Declared in null at line 20

  public int getIndexOfChild(ASTNode node) {
    if(node != null && node.childIndex < getNumChild() && node == getChildNoTransform(node.childIndex))
      return node.childIndex;
    for(int i = 0; i < getNumChild(); i++)
      if(getChildNoTransform(i) == node) {
        node.childIndex = i;
        return i;
      }
    return -1;
  }

    // Declared in null at line 31


  public void addChild(ASTNode node) {
    setChild(node, getNumChild());
  }

    // Declared in null at line 34

  public ASTNode getChildNoTransform(int i) {
    return children[i];
  }

    // Declared in null at line 37

  protected ASTNode parent;

    // Declared in null at line 38

  protected ASTNode[] children;

    // Declared in null at line 39

  protected int numChildren;

    // Declared in null at line 40

  protected int numChildren() {
    return numChildren;
  }

    // Declared in null at line 43

  public int getNumChild() {
    return numChildren();
  }

    // Declared in null at line 46

  public void setChild(ASTNode node, int i) {
    if(children == null) {
      children = new ASTNode[i + 1];
    } else if (i >= children.length) {
      ASTNode c[] = new ASTNode[i << 1];
      System.arraycopy(children, 0, c, 0, children.length);
      children = c;
    }
    children[i] = node;
    if(i >= numChildren) numChildren = i+1;
    if(node != null) { node.setParent(this); node.childIndex = i; }
  }

    // Declared in null at line 58

  public void insertChild(ASTNode node, int i) {
    if(children == null) {
      children = new ASTNode[i + 1];
      children[i] = node;
    } else {
      ASTNode c[] = new ASTNode[children.length + 1];
      System.arraycopy(children, 0, c, 0, i);
      c[i] = node;
      if(i < children.length)
        System.arraycopy(children, i, c, i+1, children.length-i);
      children = c;
    }
    numChildren++;
    if(node != null) { node.setParent(this); node.childIndex = i; }
  }

    // Declared in null at line 73

  public ASTNode getParent() {
    return parent;
  }

    // Declared in null at line 76

  public void setParent(ASTNode node) {
    parent = node;
  }

    // Declared in null at line 79

    public static void reset() {
        IN_CIRCLE = false;
        CHANGE = false;
        LAST_CYCLE = false;
    }

    protected boolean getParentPRDAssemblyVer_visited = false;
/** This is a hack used for the released flag check. 
	 *  (as ASTNode cannot inherit ai())
	 * @return the PRDAssemblyVer at the root of the tree or null
	 
    Declared in AssemblyVersioning.jadd at line 195
*/
    public PRDAssemblyVer getParentPRDAssemblyVer() {
        if(getParentPRDAssemblyVer_visited)
            throw new RuntimeException("Circular definition of attr: getParentPRDAssemblyVer in class: ");
        getParentPRDAssemblyVer_visited = true;
        PRDAssemblyVer getParentPRDAssemblyVer_value = getParentPRDAssemblyVer_compute();
        getParentPRDAssemblyVer_visited = false;
        return getParentPRDAssemblyVer_value;
    }

    private PRDAssemblyVer getParentPRDAssemblyVer_compute()  {
		ASTNode parent = getParent();
		if(parent != null) 
			return parent.getParentPRDAssemblyVer();
		else
			return null;
	}

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 48
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
		ArrayList l = new ArrayList();
		for(int i = 0; i < getNumChild(); i++) {
			l.addAll(l.size(),getChild(i).getErrorList());
		}
		return l;
	}

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 51
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute() {  return  getClass().getName();  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 156
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getBrowserLabel();  }

    protected boolean prettyPrintChildren_visited = false;
    // Declared in PrettyPrint.jrag at line 47
    public boolean prettyPrintChildren() {
        if(prettyPrintChildren_visited)
            throw new RuntimeException("Circular definition of attr: prettyPrintChildren in class: ");
        prettyPrintChildren_visited = true;
        boolean prettyPrintChildren_value = prettyPrintChildren_compute();
        prettyPrintChildren_visited = false;
        return prettyPrintChildren_value;
    }

    private boolean prettyPrintChildren_compute() {  return  true;  }

    protected boolean getPrettyString_visited = false;
    // Declared in PrettyPrint.jrag at line 50
    public String getPrettyString() {
        if(getPrettyString_visited)
            throw new RuntimeException("Circular definition of attr: getPrettyString in class: ");
        getPrettyString_visited = true;
        String getPrettyString_value = getPrettyString_compute();
        getPrettyString_visited = false;
        return getPrettyString_value;
    }

    private String getPrettyString_compute() {  return  getAssemblyLabel();  }

    protected boolean getPrettyClosingString_visited = false;
    // Declared in PrettyPrint.jrag at line 51
    public String getPrettyClosingString() {
        if(getPrettyClosingString_visited)
            throw new RuntimeException("Circular definition of attr: getPrettyClosingString in class: ");
        getPrettyClosingString_visited = true;
        String getPrettyClosingString_value = getPrettyClosingString_compute();
        getPrettyClosingString_visited = false;
        return getPrettyClosingString_value;
    }

    private String getPrettyClosingString_compute() {  return  "";  }

    protected boolean encloseInBraces_visited = false;
    // Declared in PrettyPrint.jrag at line 52
    public boolean encloseInBraces() {
        if(encloseInBraces_visited)
            throw new RuntimeException("Circular definition of attr: encloseInBraces in class: ");
        encloseInBraces_visited = true;
        boolean encloseInBraces_value = encloseInBraces_compute();
        encloseInBraces_visited = false;
        return encloseInBraces_value;
    }

    private boolean encloseInBraces_compute() {  return  false;  }

    protected boolean getIndent_visited = false;
    // Declared in PrettyPrint.jrag at line 53
    public String getIndent() {
        if(getIndent_visited)
            throw new RuntimeException("Circular definition of attr: getIndent in class: ");
        getIndent_visited = true;
        String getIndent_value = getIndent_compute();
        getIndent_visited = false;
        return getIndent_value;
    }

    private String getIndent_compute() {  return  "    ";  }

    public Device Define_Device_parentDevice(ASTNode caller, ASTNode child) {
        return getParent().Define_Device_parentDevice(this, caller);
    }
    public AbstractResourceAddress Define_AbstractResourceAddress_custServiceAddress(ASTNode caller, ASTNode child) {
        return getParent().Define_AbstractResourceAddress_custServiceAddress(this, caller);
    }
    public Service Define_Service_inhProv(ASTNode caller, ASTNode child, Connection c) {
        return getParent().Define_Service_inhProv(this, caller, c);
    }
    public Identifier Define_Identifier_getLocalName(ASTNode caller, ASTNode child) {
        return getParent().Define_Identifier_getLocalName(this, caller);
    }
    public CommandInfo Define_CommandInfo_ci(ASTNode caller, ASTNode child) {
        return getParent().Define_CommandInfo_ci(this, caller);
    }
    public String Define_String_expectedType(ASTNode caller, ASTNode child) {
        return getParent().Define_String_expectedType(this, caller);
    }
    public NetworkNode Define_NetworkNode_lookup(ASTNode caller, ASTNode child, Object o) {
        return getParent().Define_NetworkNode_lookup(this, caller, o);
    }
    public Universe Define_Universe_universe(ASTNode caller, ASTNode child) {
        return getParent().Define_Universe_universe(this, caller);
    }
    public AbstractResourceAddress Define_AbstractResourceAddress_provServiceAddress(ASTNode caller, ASTNode child) {
        return getParent().Define_AbstractResourceAddress_provServiceAddress(this, caller);
    }
    public PRDAssemblyVer Define_PRDAssemblyVer_av(ASTNode caller, ASTNode child) {
        return getParent().Define_PRDAssemblyVer_av(this, caller);
    }
    public Service Define_Service_parentService(ASTNode caller, ASTNode child) {
        return getParent().Define_Service_parentService(this, caller);
    }
    public Service Define_Service_inhCust(ASTNode caller, ASTNode child, Connection c) {
        return getParent().Define_Service_inhCust(this, caller, c);
    }
}
