/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;

/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

public abstract class AbstractXMLRepresentable extends ASTNode implements Cloneable,  ist.palcom.xml.XMLRepresentable {
    public void flushCache() {
        super.flushCache();
        getBrowserLabel_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        AbstractXMLRepresentable node = (AbstractXMLRepresentable)super.clone();
        node.getBrowserLabel_visited = false;
    return node;
    }
    // Declared in AssemblyComparison.jadd at line 54

//  public boolean PRDAssembly.equals(Object o) {
//    if (o instanceof PRDAssembly) {

    public boolean equals(Object o) {
        if (o instanceof AbstractXMLRepresentable) {
            // TODO Refine this inefficient implementation of equals
            AbstractXMLRepresentable a = (AbstractXMLRepresentable) o;
            String meAsString = new String(getXMLData()); 
            String aAsString = new String(a.getXMLData());
            return meAsString.equals(aAsString);
        } else {
            return false;
        }
    }

    // Declared in OnLineEditing.jadd at line 41

	public void addToAssembly(Assembly a) {
		System.out.println("addToAssembly not implemented for "+this);
	}

    // Declared in OnLineEditing.jadd at line 94
	

	public void removeFromAssembly(Assembly a) {
		System.out.println("removeFromAssembly not implemented for "+this);
	}

    // Declared in XML.jadd at line 48


    public byte[] getXMLData() {
    	return getXMLData(true);
    }

    // Declared in XML.jadd at line 52

    
    public byte[] getXMLData(boolean includeDTD) {
        try {
            ByteArrayOutputStream resultStream = new ByteArrayOutputStream();

            KXmlSerializer serializer = new KXmlSerializer();
            serializer.setOutput(resultStream, null);
            serializer.setFeature(
                    "http://xmlpull.org/v1/doc/features.html#indent-output",
                    true);

            if(includeDTD) {
            	serializer.startDocument("ISO-8859-1", null);
            	serializer.docdecl(" " + getTagName() + " SYSTEM \""
                    + XMLFactory.DTD + "\"");
            }
            writeXMLElement(serializer);
            serializer.endDocument();

            return resultStream.toByteArray();
        } catch (IOException e) {
            throw new RuntimeException("getXMLData: " + e);
        }
    }

    // Declared in XML.jadd at line 77

    
    /** The implementation up here is empty. */
    public void addChildFromXMLElement(XMLRepresentable child) {}

    // Declared in XML.jadd at line 79

    
    public String toString() {
        return new String(getXMLData());
    }

    // Declared in XML.jadd at line 83

    
    public abstract String getTagName();

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 36

    public AbstractXMLRepresentable() {
        super();


    }

    // Declared in PalcomResourceDescriptor.ast at line 9


  protected int numChildren() {
    return 0;
  }

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 55
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute() {  return  getTagName();  }

}
