/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public abstract class AddressPart extends AbstractXMLRepresentable implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        AddressPart node = (AddressPart)super.clone();
    return node;
    }
    // Declared in Addressing.jadd at line 48

    
    public String toString() {
    	if(getDeviceID() != null && getServicePartID() != null) {
        	return getDeviceID().getString() + "/" + getServicePartID();
        } else if(getDeviceID() != null) {
        	return getDeviceID().getString();
        } else if(getServicePartID() != null){
        	return getServicePartID();
        } 
        return null;
    }

    // Declared in Comparison.jadd at line 69

    
    public boolean equals(Object o) {
    	if (o instanceof AddressPart) {
            if(AddressPart.safeEqual(((AddressPart) o).getDeviceID(), getDeviceID())) {
            	return AddressPart.safeEqual(((AddressPart) o).getServicePartID(), getServicePartID());
            } else {
            	return false;
            }
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 102

    
    protected static boolean safeEqual(Object o1, Object o2) {
        if (o1 == null && o2 == null) {
            return true;
        } else if (o1 != null && o2 != null) {
            return o1.equals(o2);
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 579

    
    public int hashCode() {
    	return toString().hashCode();
    }

    // Declared in XML.jadd at line 940


	public void addChildFromXMLElement(XMLRepresentable child) {   
		if(child instanceof DeviceID) {
			setDeviceID((DeviceID)child);
		}
	}

    // Declared in XML.jadd at line 946
 
	
	public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        serializer.attribute(null, "id", getServicePartID());
        getDeviceID().writeXMLElement(serializer);
        serializer.endTag(null, getTagName());
    }

    // Declared in XML.jadd at line 954
   
	
	public void initializeFromElement(XmlPullParser parser) {
		setServicePartID(parser.getAttributeValue(null, "id"));
	}

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 87

    public AddressPart() {
        super();

        setChild(null, 0);

    }

    // Declared in PalcomResourceDescriptor.ast at line 11


    // Declared in PalcomResourceDescriptor.ast line 87
    public AddressPart(DeviceID p0, String p1) {
        setChild(p0, 0);
        setServicePartID(p1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 16


  protected int numChildren() {
    return 1;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 87
    public void setDeviceID(DeviceID node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public DeviceID getDeviceID() {
        return (DeviceID)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public DeviceID getDeviceIDNoTransform() {
        return (DeviceID)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 87
    private String tokenString_ServicePartID;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setServicePartID(String value) {
        tokenString_ServicePartID = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getServicePartID() {
        return tokenString_ServicePartID;
    }

}
