/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ConnectionDecl extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
        lookupConnection_ServiceExp_visited = new java.util.HashSet(4);
        getAssemblyLabel_visited = false;
        prettyPrintChildren_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ConnectionDecl node = (ConnectionDecl)super.clone();
        node.lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
        node.lookupConnection_ServiceExp_visited = new java.util.HashSet(4);
        node.getAssemblyLabel_visited = false;
        node.prettyPrintChildren_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ConnectionDecl node = (ConnectionDecl)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ConnectionDecl res = (ConnectionDecl)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyScript.jadd at line 137


//	public String ServiceOnDevice.getURN() {
//		ServiceDecl d = av().lookupService(getServiceUse(), getDeviceUse());
//		if(d != null) 
//			return d.getURN();
//		else
//			return "UNKNOWN SERVICE ("+getServiceUse().getIdentifier().getID()+")";
//	}

//	public PRDConnection ConnectionDecl.asInfo() {
//		LocalSID prov = getProvider().getLocalSID();
//		LocalSID cust = getCustomer().getLocalSID();
//		return new PRDConnection(prov, cust);
//	}
	public ConnectionInfo asInfo() {
		AbstractResourceAddress prov = getProvider().getServiceAddress();
		AbstractResourceAddress cust = getCustomer().getServiceAddress();
		return new ConnectionInfo(prov, cust, new Opt());
	}

    // Declared in AssemblyXML.jadd at line 245

	
    

    public String getTagName() {
    	return "ConnectionDecl";
    }

    // Declared in AssemblyXML.jadd at line 249

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        getProvider().writeXMLElement(serializer);
        getCustomer().writeXMLElement(serializer);
        serializer.endTag(null, getTagName());
    }

    // Declared in AssemblyXML.jadd at line 257

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in AssemblyXML.jadd at line 260


    public void addChildFromXMLElement(XMLRepresentable child) {
    	if(getProvider() == null) {
    		setProvider((ServiceExp) child);
    	} else {
    		setCustomer((ServiceExp) child);
    	}
    		
	}

    // Declared in OnLineEditing.jadd at line 85

		
	public void addToAssembly(Assembly a) {
		PRDAssemblyVer ai = a.assemblyVer;
		ai.getConnections().addConnectionDecl(this);		
		//TODO: just change this references on this
  		a.setThisReferencesToDeviceID();
  		a.doRequestConnection(this);
		ai.resetTree();
	}

    // Declared in OnLineEditing.jadd at line 112

	
	public void removeFromAssembly(Assembly a) {
		PRDAssemblyVer ai = a.assemblyVer;
		a.doRequestDisconnection(this);
		ai.getConnections().lookupConnection(getCustomer(), getProvider()).remove();
		ai.resetTree();
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 51

    public ConnectionDecl() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in Assembly.ast at line 12


    // Declared in Assembly.ast line 51
    public ConnectionDecl(ServiceExp p0, ServiceExp p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in Assembly.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 51
    public void setProvider(ServiceExp node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public ServiceExp getProvider() {
        return (ServiceExp)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public ServiceExp getProviderNoTransform() {
        return (ServiceExp)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 51
    public void setCustomer(ServiceExp node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public ServiceExp getCustomer() {
        return (ServiceExp)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public ServiceExp getCustomerNoTransform() {
        return (ServiceExp)getChildNoTransform(1);
    }

    protected java.util.Set lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 329
    public ConnectionDecl lookupConnection(ServiceExp cust, ServiceExp prov) {
        java.util.List _parameters = new java.util.ArrayList(2);
        _parameters.add(cust);
        _parameters.add(prov);
        if(lookupConnection_ServiceExp_ServiceExp_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupConnection in class: ");
        lookupConnection_ServiceExp_ServiceExp_visited.add(_parameters);
        ConnectionDecl lookupConnection_ServiceExp_ServiceExp_value = lookupConnection_compute(cust, prov);
        lookupConnection_ServiceExp_ServiceExp_visited.remove(_parameters);
        return lookupConnection_ServiceExp_ServiceExp_value;
    }

    private ConnectionDecl lookupConnection_compute(ServiceExp cust, ServiceExp prov) {  return  
        cust.equals(getCustomer()) && prov.equals(getProvider()) ? this : null;  }

    protected java.util.Set lookupConnection_ServiceExp_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 357
    public ConnectionDecl lookupConnection(ServiceExp svc) {
        Object _parameters = svc;
        if(lookupConnection_ServiceExp_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupConnection in class: ");
        lookupConnection_ServiceExp_visited.add(_parameters);
        ConnectionDecl lookupConnection_ServiceExp_value = lookupConnection_compute(svc);
        lookupConnection_ServiceExp_visited.remove(_parameters);
        return lookupConnection_ServiceExp_value;
    }

    private ConnectionDecl lookupConnection_compute(ServiceExp svc)  {
//        svc.equals(getCustomer()) || svc.equals(getProvider()) ? this : null;
		if(svc instanceof ServiceUse) {
			Identifier id = ((ServiceUse)svc).getIdentifier();
			return getCustomer().matches(id) || getProvider().matches(id) ? this : null;
		} else if (svc instanceof ThisService){ 
			return ((getCustomer() instanceof ThisService) || (getProvider() instanceof ThisService))?this:null;
		} else {
			return null;
		}
	}

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 176
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getProvider().getAssemblyLabel()+" -->"+getCustomer().getAssemblyLabel();  }

    protected boolean prettyPrintChildren_visited = false;
    // Declared in PrettyPrint.jrag at line 63
    public boolean prettyPrintChildren() {
        if(prettyPrintChildren_visited)
            throw new RuntimeException("Circular definition of attr: prettyPrintChildren in class: ");
        prettyPrintChildren_visited = true;
        boolean prettyPrintChildren_value = prettyPrintChildren_compute();
        prettyPrintChildren_visited = false;
        return prettyPrintChildren_value;
    }

    private boolean prettyPrintChildren_compute() {  return  false;  }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 64
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
