/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;




public abstract class ControlInfo extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupCommand_String_visited = new java.util.HashSet(4);
        encloseInBraces_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ControlInfo node = (ControlInfo)super.clone();
        node.lookupCommand_String_visited = new java.util.HashSet(4);
        node.encloseInBraces_visited = false;
    return node;
    }
    // Declared in ServiceDescription.jadd at line 630

    
    //    refine Aspect void Group.addControlItem(ControlItem node) {
//        Aspect.Group.addControlItem(node);
//        node.getInfo().addControlInfo(node.getInfo());
//    }
    
//    refine Info String Info.getName() {
//        System.out.println("getName");
//        return Info.Info.getName();
//    }
    
    public abstract ControlItem createInstance();

    // Declared in Comparison.jadd at line 426


    public boolean equals(Object o) {
        if (!(o instanceof ControlInfo)) {
            return false;
        } else {
            ControlInfo data = (ControlInfo) o;
            return PRDData.safeEqual(data.getID(), getID());
        }
    }

    // Declared in Comparison.jadd at line 587


    public int hashCode() {
    	if(getID() != null)
	        return getID().hashCode();
	    else
	    	return super.hashCode();
    }

    // Declared in XML.jadd at line 311


    public void initializeFromElement(XmlPullParser parser) {
        setID(parser.getAttributeValue(null, "id"));
        setHelp(parser.getAttributeValue(null, "help"));
    }

    // Declared in XML.jadd at line 867
    
    
    protected void writeStartTagAndAttributes(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        if (getID() != null) {
            serializer.attribute(null, "id", getID());
        }
        if (getHelp() != null) {
            serializer.attribute(null, "help", getHelp());
        }
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 69

    public ControlInfo() {
        super();


    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    // Declared in PalcomResourceDescriptor.ast line 69
    public ControlInfo(String p0, String p1) {
        setID(p0);
        setHelp(p1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 15


  protected int numChildren() {
    return 0;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 69
    private String tokenString_ID;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setID(String value) {
        tokenString_ID = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getID() {
        return tokenString_ID;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 69
    private String tokenString_Help;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setHelp(String value) {
        tokenString_Help = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getHelp() {
        return tokenString_Help;
    }

    protected java.util.Set lookupCommand_String_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 200
    public ControlInfo lookupCommand(String id) {
        Object _parameters = id;
        if(lookupCommand_String_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupCommand in class: ");
        lookupCommand_String_visited.add(_parameters);
        ControlInfo lookupCommand_String_value = lookupCommand_compute(id);
        lookupCommand_String_visited.remove(_parameters);
        return lookupCommand_String_value;
    }

    private ControlInfo lookupCommand_compute(String id) {  return  null;  }

    protected boolean encloseInBraces_visited = false;
    // Declared in PrettyPrint.jrag at line 74
    public boolean encloseInBraces() {
        if(encloseInBraces_visited)
            throw new RuntimeException("Circular definition of attr: encloseInBraces in class: ");
        encloseInBraces_visited = true;
        boolean encloseInBraces_value = encloseInBraces_compute();
        encloseInBraces_visited = false;
        return encloseInBraces_value;
    }

    private boolean encloseInBraces_compute() {  return  true;  }

}
