/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ControlService extends Service implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupCommand_String_visited = new java.util.HashSet(4);
    }
    public Object clone() throws CloneNotSupportedException {
        ControlService node = (ControlService)super.clone();
        node.lookupCommand_String_visited = new java.util.HashSet(4);
    return node;
    }
    public ASTNode copy() {
      try {
          ControlService node = (ControlService)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ControlService res = (ControlService)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 134


public void wasDisconnected() {
	//Hack when SD is optional
	if(hasProxy()) {
		getProxyOpt().removeChild(getProxyOpt().getIndexOfChild(getProxy()));
	}
//	setDescription(null);
}

    // Declared in DeviceTree.jadd at line 306


   public Object[] getChildArray() {
   		Object[] result;
   		if(isNotOK()) {
   			result = new Object[] {
	   			"Problem: "+getStatusHelpText(), 
   				hasProxy() ? (Object) getProxy() : "No proxy",
   				getDescription()!=null ? (Object) getDescription() : "No description"
   			};
   		} else {
   			result = new Object[] {
	   			hasProxy() ? (Object) getProxy() : "No proxy",
   				getDescription()!=null ? (Object) getDescription() : "No description"
   			};
   		}
   		return result;
   }

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 48

    public ControlService() {
        super();

        setChild(null, 0);
        setChild(null, 1);
        setChild(new Opt(), 2);

    }

    // Declared in LocalView.ast at line 13


    // Declared in LocalView.ast line 48
    public ControlService(ServiceInfo p0, ServiceDescription p1, Opt p2) {
        setChild(p0, 0);
        setChild(p1, 1);
        setChild(p2, 2);
    }

    // Declared in LocalView.ast at line 19


  protected int numChildren() {
    return 3;
  }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 46
    public void setInfo(ServiceInfo node) {
        setChild(node, 0);
    }

    // Declared in LocalView.ast at line 5

    public ServiceInfo getInfo() {
        return (ServiceInfo)getChild(0);
    }

    // Declared in LocalView.ast at line 9


    public ServiceInfo getInfoNoTransform() {
        return (ServiceInfo)getChildNoTransform(0);
    }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 48
    public void setDescription(ServiceDescription node) {
        setChild(node, 1);
    }

    // Declared in LocalView.ast at line 5

    public ServiceDescription getDescription() {
        return (ServiceDescription)getChild(1);
    }

    // Declared in LocalView.ast at line 9


    public ServiceDescription getDescriptionNoTransform() {
        return (ServiceDescription)getChildNoTransform(1);
    }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 48
    public void setProxyOpt(Opt opt) {
        setChild(opt, 2);
    }

    // Declared in LocalView.ast at line 6


    public boolean hasProxy() {
        return getProxyOpt().getNumChild() != 0;
    }

    // Declared in LocalView.ast at line 10


    public ServiceProxy getProxy() {
        return (ServiceProxy)getProxyOpt().getChild(0);
    }

    // Declared in LocalView.ast at line 14


    public void setProxy(ServiceProxy node) {
        getProxyOpt().setChild(node, 0);
    }

    // Declared in LocalView.ast at line 17

    public Opt getProxyOpt() {
        return (Opt)getChild(2);
    }

    // Declared in LocalView.ast at line 21


    public Opt getProxyOptNoTransform() {
        return (Opt)getChildNoTransform(2);
    }

    protected java.util.Set lookupCommand_String_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 187
    public CommandInfo lookupCommand(String id) {
        Object _parameters = id;
        if(lookupCommand_String_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupCommand in class: ");
        lookupCommand_String_visited.add(_parameters);
        CommandInfo lookupCommand_String_value = lookupCommand_compute(id);
        lookupCommand_String_visited.remove(_parameters);
        return lookupCommand_String_value;
    }

    private CommandInfo lookupCommand_compute(String id)  {
	return (CommandInfo) getDescription().lookupCommand(id);
}

    // Declared in AssemblyTree.jadd at line 176
    public Service Define_Service_parentService(ASTNode caller, ASTNode child) {
        if(caller == getProxyOptNoTransform()) {
            return  this;
        }
        if(caller == getDescriptionNoTransform()) {
            return  this;
        }
        return getParent().Define_Service_parentService(this, caller);
    }

}
