/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class Device extends NetworkNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getBrowserLabel_visited = false;
        localLookup_Object_visited = new java.util.HashSet(4);
        isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
        matchesInfo_Info_visited = new java.util.HashSet(4);
        matches_Object_visited = new java.util.HashSet(4);
        getName_visited = false;
        getAddress_visited = false;
        getNumServiceListPart_visited = false;
        getServiceListPart_int_visited = new java.util.HashSet(4);
        universe_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        Device node = (Device)super.clone();
        node.getBrowserLabel_visited = false;
        node.localLookup_Object_visited = new java.util.HashSet(4);
        node.isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.matchesInfo_Info_visited = new java.util.HashSet(4);
        node.matches_Object_visited = new java.util.HashSet(4);
        node.getName_visited = false;
        node.getAddress_visited = false;
        node.getNumServiceListPart_visited = false;
        node.getServiceListPart_int_visited = new java.util.HashSet(4);
        node.universe_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          Device node = (Device)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        Device res = (Device)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 238

   
   public Object[] getChildArray() {
   		int cnt=getNumService();
//   		System.err.println("Device.getChildArray: cnt = "+cnt);
   		Object tmp[] = new Object[cnt];
		for(int i=0; i<cnt; i++) {
			tmp[i] = getService(i);
		}
		return tmp;
   }

    // Declared in DeviceTree.jadd at line 364


   	public String toString() {
   		return "Device: "+getInfo().toString();
	}

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 43

    public Device() {
        super();

        setChild(null, 0);
        setChild(new List(), 1);

    }

    // Declared in LocalView.ast at line 12


    // Declared in LocalView.ast line 43
    public Device(DeviceInfo p0, List p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in LocalView.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 43
    public void setInfo(DeviceInfo node) {
        setChild(node, 0);
    }

    // Declared in LocalView.ast at line 5

    public DeviceInfo getInfo() {
        return (DeviceInfo)getChild(0);
    }

    // Declared in LocalView.ast at line 9


    public DeviceInfo getInfoNoTransform() {
        return (DeviceInfo)getChildNoTransform(0);
    }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 43
    public void setServiceList(List list) {
        setChild(list, 1);
    }

    // Declared in LocalView.ast at line 6


    public int getNumService() {
        return getServiceList().getNumChild();
    }

    // Declared in LocalView.ast at line 10


    public ServiceListPart getService(int i) {
        return (ServiceListPart)getServiceList().getChild(i);
    }

    // Declared in LocalView.ast at line 14


    public void addService(ServiceListPart node) {
        List list = getServiceList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in LocalView.ast at line 19


    public void setService(ServiceListPart node, int i) {
        List list = getServiceList();
        list.setChild(node, i);
    }

    // Declared in LocalView.ast at line 23

    public List getServiceList() {
        return (List)getChild(1);
    }

    // Declared in LocalView.ast at line 27


    public List getServiceListNoTransform() {
        return (List)getChildNoTransform(1);
    }

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 63
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute() {  return  getInfo().getName() + " : " + getStatus();  }

    protected java.util.Set localLookup_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 72
    public NetworkNode localLookup(Object o) {
        Object _parameters = o;
        if(localLookup_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: localLookup in class: ");
        localLookup_Object_visited.add(_parameters);
        NetworkNode localLookup_Object_value = localLookup_compute(o);
        localLookup_Object_visited.remove(_parameters);
        return localLookup_Object_value;
    }

    private NetworkNode localLookup_compute(Object o)  {
	synchronized(universe()) {

	if(matches(o)) {
		return this;
	} else {
		for(int i = 0; i < getNumService(); i++) {
			NetworkNode n = getService(i).localLookup(o);
			if(n != null) return n;
		}	
	}
	return null;	
	}
}

    protected java.util.Set isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 123
    public boolean isResource(AbstractResourceAddress a) {
        Object _parameters = a;
        if(isResource_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: isResource in class: ");
        isResource_AbstractResourceAddress_visited.add(_parameters);
        boolean isResource_AbstractResourceAddress_value = isResource_compute(a);
        isResource_AbstractResourceAddress_visited.remove(_parameters);
        return isResource_AbstractResourceAddress_value;
    }

    private boolean isResource_compute(AbstractResourceAddress a) {  return  getAddress().equals(a);  }

    protected java.util.Set matchesInfo_Info_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 136
    public boolean matchesInfo(Info i) {
        Object _parameters = i;
        if(matchesInfo_Info_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesInfo in class: ");
        matchesInfo_Info_visited.add(_parameters);
        boolean matchesInfo_Info_value = matchesInfo_compute(i);
        matchesInfo_Info_visited.remove(_parameters);
        return matchesInfo_Info_value;
    }

    private boolean matchesInfo_compute(Info i) {  return  isResource(i.getAddress());  }

    protected java.util.Set matches_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 140
    public boolean matches(Object o) {
        Object _parameters = o;
        if(matches_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matches in class: ");
        matches_Object_visited.add(_parameters);
        boolean matches_Object_value = matches_compute(o);
        matches_Object_visited.remove(_parameters);
        return matches_Object_value;
    }

    private boolean matches_compute(Object o)  {
	if(o instanceof AbstractResourceAddress)
		return isResource((AbstractResourceAddress)o);
	else if(o instanceof Info)
		return matchesInfo((Info)o);
	
//	System.out.println("Device does not match "+o);
	return false;
}

    protected boolean getName_visited = false;
    // Declared in NameAnalysis.jrag at line 162
    public String getName() {
        if(getName_visited)
            throw new RuntimeException("Circular definition of attr: getName in class: ");
        getName_visited = true;
        String getName_value = getName_compute();
        getName_visited = false;
        return getName_value;
    }

    private String getName_compute()  {
	if(getInfo() != null) return getInfo().getName();
	return null;
}

    protected boolean getAddress_visited = false;
    // Declared in NameAnalysis.jrag at line 166
    public DeviceAddress getAddress() {
        if(getAddress_visited)
            throw new RuntimeException("Circular definition of attr: getAddress in class: ");
        getAddress_visited = true;
        DeviceAddress getAddress_value = getAddress_compute();
        getAddress_visited = false;
        return getAddress_value;
    }

    private DeviceAddress getAddress_compute()  {
	if(getInfo() instanceof DeviceInfo) return ((DeviceInfo)getInfo()).getDeviceAddress();
	return null;
}

    protected boolean getNumServiceListPart_visited = false;
    // Declared in ServiceRemoval.jrag at line 11
    public int getNumServiceListPart() {
        if(getNumServiceListPart_visited)
            throw new RuntimeException("Circular definition of attr: getNumServiceListPart in class: ");
        getNumServiceListPart_visited = true;
        int getNumServiceListPart_value = getNumServiceListPart_compute();
        getNumServiceListPart_visited = false;
        return getNumServiceListPart_value;
    }

    private int getNumServiceListPart_compute() {  return  getNumService();  }

    protected java.util.Set getServiceListPart_int_visited = new java.util.HashSet(4);
    // Declared in ServiceRemoval.jrag at line 12
    public ServiceListPart getServiceListPart(int i) {
        Object _parameters = new Integer(i);
        if(getServiceListPart_int_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: getServiceListPart in class: ");
        getServiceListPart_int_visited.add(_parameters);
        ServiceListPart getServiceListPart_int_value = getServiceListPart_compute(i);
        getServiceListPart_int_visited.remove(_parameters);
        return getServiceListPart_int_value;
    }

    private ServiceListPart getServiceListPart_compute(int i) {  return  getService(i);  }

    protected boolean universe_visited = false;
    // Declared in DeviceTree.jadd at line 92
    public Universe universe() {
        if(universe_visited)
            throw new RuntimeException("Circular definition of attr: universe in class: ");
        universe_visited = true;
        Universe universe_value = getParent().Define_Universe_universe(this, null);
        universe_visited = false;
        return universe_value;
    }

    // Declared in DeviceTree.jadd at line 84
    public Device Define_Device_parentDevice(ASTNode caller, ASTNode child) {
        if(caller == getServiceListNoTransform()) {
      int childIndex = caller.getIndexOfChild(child);
            return  this;
        }
        return getParent().Define_Device_parentDevice(this, caller);
    }

}
