/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public class DeviceDecl extends PRDData implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupDevice_DeviceAddress_visited = new java.util.HashSet(4);
        lookupDevice_Identifier_visited = new java.util.HashSet(4);
        getErrorList_visited = false;
        getAssemblyLabel_visited = false;
        prettyPrintChildren_visited = false;
        getPrettyString_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        DeviceDecl node = (DeviceDecl)super.clone();
        node.lookupDevice_DeviceAddress_visited = new java.util.HashSet(4);
        node.lookupDevice_Identifier_visited = new java.util.HashSet(4);
        node.getErrorList_visited = false;
        node.getAssemblyLabel_visited = false;
        node.prettyPrintChildren_visited = false;
        node.getPrettyString_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          DeviceDecl node = (DeviceDecl)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        DeviceDecl res = (DeviceDecl)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyNameEditing.jadd at line 58


	public String getIDforEditing() {
		return getNameID().getID();
	}

    // Declared in AssemblyNameEditing.jadd at line 99

	
	public boolean updateIDfromEditor(String id) {
		if(!getNameID().getID().equals(id)) {
			getNameID().setID(id);
			return true;
		}
		return false;
	}

    // Declared in AssemblyTree.jadd at line 103


	public Object[] getChildArray() {
//		return new Object[] {getName(), getURN()};
		return new Object[] {getDeviceAddress()};
	}

    // Declared in AssemblyXML.jadd at line 193


    public String getTagName() {
    	return "DeviceDecl";
    }

    // Declared in AssemblyXML.jadd at line 197

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
//        serializer.attribute(null, "name", getNameID());                
//        serializer.attribute(null, "urn", getURN().toString());                
        getNameID().writeXMLElement(serializer);
        getDeviceAddress().writeXMLElement(serializer);
        serializer.endTag(null, getTagName());
    }

    // Declared in AssemblyXML.jadd at line 207

    
    public void initializeFromElement(XmlPullParser parser) {
//	    setNameID(parser.getAttributeValue(null, "name"));
//	    setURN(new URN(parser.getAttributeValue(null, "urn")));
    }

    // Declared in AssemblyXML.jadd at line 212


	public void addChildFromXMLElement(XMLRepresentable child) {    
		if(child instanceof Identifier) {
			setNameID((Identifier)child);
		} else if (child instanceof DeviceID) {
			setDeviceAddress(new DeviceAddress((DeviceID) child));
		}
	}

    // Declared in OnLineEditing.jadd at line 45

	
	public void addToAssembly(Assembly a) {
		PRDAssemblyVer ai = a.assemblyVer;
		ai.getDevices().addDeviceDecl(this);
		ai.resetTree();
//		connectAffectedServices(a);
	}

    // Declared in OnLineEditing.jadd at line 98

	
	public void removeFromAssembly(Assembly a) {
		PRDAssemblyVer ai = a.assemblyVer;
//		disconnectAffectedServices(a);
		ai.getDevices().lookupDevice(getNameID()).remove();
		ai.resetTree();
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 48

    public DeviceDecl() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in Assembly.ast at line 12


    // Declared in Assembly.ast line 48
    public DeviceDecl(Identifier p0, DeviceAddress p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in Assembly.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 48
    public void setNameID(Identifier node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public Identifier getNameID() {
        return (Identifier)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public Identifier getNameIDNoTransform() {
        return (Identifier)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 48
    public void setDeviceAddress(DeviceAddress node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public DeviceAddress getDeviceAddress() {
        return (DeviceAddress)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public DeviceAddress getDeviceAddressNoTransform() {
        return (DeviceAddress)getChildNoTransform(1);
    }

    protected java.util.Set lookupDevice_DeviceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 74
    public DeviceDecl lookupDevice(DeviceAddress did) {
        Object _parameters = did;
        if(lookupDevice_DeviceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupDevice in class: ");
        lookupDevice_DeviceAddress_visited.add(_parameters);
        DeviceDecl lookupDevice_DeviceAddress_value = lookupDevice_compute(did);
        lookupDevice_DeviceAddress_visited.remove(_parameters);
        return lookupDevice_DeviceAddress_value;
    }

    private DeviceDecl lookupDevice_compute(DeviceAddress did) {  return  
        did.matches(getDeviceAddress()) ? this : null;  }

    protected java.util.Set lookupDevice_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 94
    public DeviceDecl lookupDevice(Identifier id) {
        Object _parameters = id;
        if(lookupDevice_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupDevice in class: ");
        lookupDevice_Identifier_visited.add(_parameters);
        DeviceDecl lookupDevice_Identifier_value = lookupDevice_compute(id);
        lookupDevice_Identifier_visited.remove(_parameters);
        return lookupDevice_Identifier_value;
    }

    private DeviceDecl lookupDevice_compute(Identifier id) {  return  
        id.equals(getNameID()) ? this : null;  }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 58
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
		ArrayList l = new ArrayList();
		if(getDeviceAddress() instanceof UnboundDeviceAddress) {
    		l.add(new SemanticError(SemanticError.TYPE_ERROR,"Unbound device "+getNameID().getID(),this));
    	}
    	return l;
    }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 167
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getNameID().getAssemblyLabel();  }

    protected boolean prettyPrintChildren_visited = false;
    // Declared in PrettyPrint.jrag at line 61
    public boolean prettyPrintChildren() {
        if(prettyPrintChildren_visited)
            throw new RuntimeException("Circular definition of attr: prettyPrintChildren in class: ");
        prettyPrintChildren_visited = true;
        boolean prettyPrintChildren_value = prettyPrintChildren_compute();
        prettyPrintChildren_visited = false;
        return prettyPrintChildren_value;
    }

    private boolean prettyPrintChildren_compute() {  return  false;  }

    protected boolean getPrettyString_visited = false;
    // Declared in PrettyPrint.jrag at line 79
    public String getPrettyString() {
        if(getPrettyString_visited)
            throw new RuntimeException("Circular definition of attr: getPrettyString in class: ");
        getPrettyString_visited = true;
        String getPrettyString_value = getPrettyString_compute();
        getPrettyString_visited = false;
        return getPrettyString_value;
    }

    private String getPrettyString_compute() {  return  super.getPrettyString() +" : " +getDeviceAddress();  }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 57
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
