/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public class DeviceID extends AbstractXMLRepresentable implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        DeviceID node = (DeviceID)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          DeviceID node = (DeviceID)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        DeviceID res = (DeviceID)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Addressing.jadd at line 42

    
    /** Prefix for PalCom DeviceIDs. */
    public static final String DID_PREFIX = "X:";

    // Declared in Addressing.jadd at line 83

    
    public String toString() {
    	return getString();
    }

    // Declared in Comparison.jadd at line 81

    
    public boolean equals(Object o) {
    	if(o instanceof DeviceID) {
    		return AddressPart.safeEqual(((DeviceID) o).getString(), getString());
    	} else if(o instanceof String) {
    		throw new Error("DeviceID is no longer a string");
    	}
    	return false;
    }

    // Declared in Comparison.jadd at line 583

    
    public int hashCode() {
    	return toString().hashCode();
    }

    // Declared in XML.jadd at line 900

    
   public String getTagName() {
    	return "DID";
    }

    // Declared in XML.jadd at line 904

    
    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        serializer.attribute(null, "id", getString());
        serializer.endTag(null, getTagName());
    }

    // Declared in XML.jadd at line 911

    
    public void initializeFromElement(XmlPullParser parser) {
    	setString(parser.getAttributeValue(null, "id"));
    }

    // Declared in XML.jadd at line 915


	public void addChildFromXMLElement(XMLRepresentable child) {    
	}

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 91

    public DeviceID() {
        super();


    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    // Declared in PalcomResourceDescriptor.ast line 91
    public DeviceID(String p0) {
        setString(p0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 14


  protected int numChildren() {
    return 0;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 91
    private String tokenString_String;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setString(String value) {
        tokenString_String = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getString() {
        return tokenString_String;
    }

}
