/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class HeartBeat extends ASTNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        HeartBeat node = (HeartBeat)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          HeartBeat node = (HeartBeat)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        HeartBeat res = (HeartBeat)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Addressing.jadd at line 87

    
    public String toString() {
    	ist.palcom.base.StringBuilder builder 
    		= ist.palcom.base.StringBuilder.instantiate();
    	if(getIsHeartBeatAck()) {
    		builder.append("H");
    	} else {
    		builder.append("h");
    	}
    	builder.append(";"); 
    	int length = getDeviceCache().length() + 2;
    	builder.append(length);
    	builder.append(";");
       	builder.append(getDeviceCache());
    	builder.append(";");
    	builder.appendChar((char) getDeviceStatus());
    	return builder.toString();
    }

    // Declared in Comparison.jadd at line 61

    
    public boolean equals(Object o) {
    	if (o instanceof HeartBeat) {
            return AddressPart.safeEqual(((HeartBeat) o).getDeviceID(), getDeviceID());
        } else {
            return false;
        }
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 99

    public HeartBeat() {
        super();

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in PalcomResourceDescriptor.ast at line 12


    // Declared in PalcomResourceDescriptor.ast line 99
    public HeartBeat(DeviceID p0, boolean p1, String p2, String p3, byte p4, Selector p5) {
        setChild(p0, 0);
        setIsHeartBeatAck(p1);
        setDeviceCache(p2);
        setDiscoveryVersion(p3);
        setDeviceStatus(p4);
        setChild(p5, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 21


  protected int numChildren() {
    return 2;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 99
    public void setDeviceID(DeviceID node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public DeviceID getDeviceID() {
        return (DeviceID)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public DeviceID getDeviceIDNoTransform() {
        return (DeviceID)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 99
    private boolean tokenboolean_IsHeartBeatAck;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setIsHeartBeatAck(boolean value) {
        tokenboolean_IsHeartBeatAck = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public boolean getIsHeartBeatAck() {
        return tokenboolean_IsHeartBeatAck;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 99
    private String tokenString_DeviceCache;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setDeviceCache(String value) {
        tokenString_DeviceCache = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getDeviceCache() {
        return tokenString_DeviceCache;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 99
    private String tokenString_DiscoveryVersion;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setDiscoveryVersion(String value) {
        tokenString_DiscoveryVersion = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getDiscoveryVersion() {
        return tokenString_DiscoveryVersion;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 99
    private byte tokenbyte_DeviceStatus;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setDeviceStatus(byte value) {
        tokenbyte_DeviceStatus = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public byte getDeviceStatus() {
        return tokenbyte_DeviceStatus;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 99
    public void setDiscoverySelector(Selector node) {
        setChild(node, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public Selector getDiscoverySelector() {
        return (Selector)getChild(1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public Selector getDiscoverySelectorNoTransform() {
        return (Selector)getChildNoTransform(1);
    }

}
