/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class InvokeAction extends ActionWithParams implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getAssemblyLabel_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        InvokeAction node = (InvokeAction)super.clone();
        node.getAssemblyLabel_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          InvokeAction node = (InvokeAction)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        InvokeAction res = (InvokeAction)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyXML.jadd at line 560

	
	public String getTagName() {
		return "InvokeAction";
	}

    // Declared in AssemblyXML.jadd at line 564


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        serializer.attribute(null, "command", getCommand());                
        for(int i=0; i<getNumParamValue(); i++) {
        	getParamValue(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
	}

    // Declared in AssemblyXML.jadd at line 573


	public void initializeFromElement(XmlPullParser parser) {
	    setCommand(parser.getAttributeValue(null, "command"));
	}

    // Declared in AssemblyXML.jadd at line 577


    public void addChildFromXMLElement(XMLRepresentable child) {
        addParamValue((Use) child);
    }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 86

    public InvokeAction() {
        super();

        setChild(new List(), 0);

    }

    // Declared in Assembly.ast at line 11


    // Declared in Assembly.ast line 86
    public InvokeAction(String p0, List p1) {
        setCommand(p0);
        setChild(p1, 0);
    }

    // Declared in Assembly.ast at line 16


  protected int numChildren() {
    return 1;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 84
    private String tokenString_Command;

    // Declared in Assembly.ast at line 3

    public void setCommand(String value) {
        tokenString_Command = value;
    }

    // Declared in Assembly.ast at line 6

    public String getCommand() {
        return tokenString_Command;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 84
    public void setParamValueList(List list) {
        setChild(list, 0);
    }

    // Declared in Assembly.ast at line 6


    public int getNumParamValue() {
        return getParamValueList().getNumChild();
    }

    // Declared in Assembly.ast at line 10


    public Use getParamValue(int i) {
        return (Use)getParamValueList().getChild(i);
    }

    // Declared in Assembly.ast at line 14


    public void addParamValue(Use node) {
        List list = getParamValueList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in Assembly.ast at line 19


    public void setParamValue(Use node, int i) {
        List list = getParamValueList();
        list.setChild(node, i);
    }

    // Declared in Assembly.ast at line 23

    public List getParamValueList() {
        return (List)getChild(0);
    }

    // Declared in Assembly.ast at line 27


    public List getParamValueListNoTransform() {
        return (List)getChildNoTransform(0);
    }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 211
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute()  {
		String params = "";
		if(getNumParamValue() > 0) {
			params = getParamValue(0).getAssemblyLabel();
			for (int i = 1; i < getNumParamValue(); i++) {
				params = params + ", " + getParamValue(i).getAssemblyLabel();
			}
		}
		return "invoke "+getCommand() + "("+params +")";
	}

    protected boolean av_visited = false;
    // Declared in ErrorChecking.jrag at line 116
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

    // Declared in AssemblyTypeAnalysis.jrag at line 83
    public String Define_String_expectedType(ASTNode caller, ASTNode child) {
        if(caller == getParamValueListNoTransform()) { 
   int i = caller.getIndexOfChild(child);
 {
	CommandInfo ci = null;
	if(av().hasPRDServiceFMDescription()) {
		ci = (CommandInfo) av().getPRDServiceFMDescription().lookupCommand(getCommand());
	}
	if(ci != null) {
		return ci.getParamInfo(i).getType();
	}
	return "unknown";
}
}
        return super.Define_String_expectedType(caller, child);
    }

}
