/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class Network extends NetworkNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getBrowserLabel_visited = false;
        localLookup_Object_visited = new java.util.HashSet(4);
        universe_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        Network node = (Network)super.clone();
        node.getBrowserLabel_visited = false;
        node.localLookup_Object_visited = new java.util.HashSet(4);
        node.universe_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          Network node = (Network)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        Network res = (Network)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 222


	
	public Object[] getChildArray() {	
		Object tmp[] = new Object[getNumDevice()];
		for(int i=0; i<getNumDevice(); i++) {
			tmp[i] = getDevice(i);
		}
		return tmp;
   }

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 42

    public Network() {
        super();

        setChild(new List(), 0);

    }

    // Declared in LocalView.ast at line 11


    // Declared in LocalView.ast line 42
    public Network(String p0, List p1) {
        setName(p0);
        setChild(p1, 0);
    }

    // Declared in LocalView.ast at line 16


  protected int numChildren() {
    return 1;
  }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 42
    private String tokenString_Name;

    // Declared in LocalView.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in LocalView.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 42
    public void setDeviceList(List list) {
        setChild(list, 0);
    }

    // Declared in LocalView.ast at line 6


    public int getNumDevice() {
        return getDeviceList().getNumChild();
    }

    // Declared in LocalView.ast at line 10


    public Device getDevice(int i) {
        return (Device)getDeviceList().getChild(i);
    }

    // Declared in LocalView.ast at line 14


    public void addDevice(Device node) {
        List list = getDeviceList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in LocalView.ast at line 19


    public void setDevice(Device node, int i) {
        List list = getDeviceList();
        list.setChild(node, i);
    }

    // Declared in LocalView.ast at line 23

    public List getDeviceList() {
        return (List)getChild(0);
    }

    // Declared in LocalView.ast at line 27


    public List getDeviceListNoTransform() {
        return (List)getChildNoTransform(0);
    }

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 61
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute() {  return  getName();  }

    protected java.util.Set localLookup_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 62
    public NetworkNode localLookup(Object o) {
        Object _parameters = o;
        if(localLookup_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: localLookup in class: ");
        localLookup_Object_visited.add(_parameters);
        NetworkNode localLookup_Object_value = localLookup_compute(o);
        localLookup_Object_visited.remove(_parameters);
        return localLookup_Object_value;
    }

    private NetworkNode localLookup_compute(Object o)  {
	synchronized(universe()) {	
	for(int i = 0; i < getNumDevice(); i++) {
		NetworkNode n = getDevice(i).localLookup(o);
		if(n != null) return n;
	}
	return null;
	}
}

    protected boolean universe_visited = false;
    // Declared in NameAnalysis.jrag at line 42
    public Universe universe() {
        if(universe_visited)
            throw new RuntimeException("Circular definition of attr: universe in class: ");
        universe_visited = true;
        Universe universe_value = getParent().Define_Universe_universe(this, null);
        universe_visited = false;
        return universe_value;
    }

}
