/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;

/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// Device side tree view of the network, 
// with device and service hierarchy

public abstract class NetworkNode extends ASTNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
        matchesInfo_Info_visited = new java.util.HashSet(4);
        matches_Object_visited = new java.util.HashSet(4);
        getNumServiceListPart_visited = false;
        getServiceListPart_int_visited = new java.util.HashSet(4);
        lookup_Object_visited = new java.util.HashSet(4);
    }
    public Object clone() throws CloneNotSupportedException {
        NetworkNode node = (NetworkNode)super.clone();
        node.isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.matchesInfo_Info_visited = new java.util.HashSet(4);
        node.matches_Object_visited = new java.util.HashSet(4);
        node.getNumServiceListPart_visited = false;
        node.getServiceListPart_int_visited = new java.util.HashSet(4);
        node.lookup_Object_visited = new java.util.HashSet(4);
    return node;
    }
    // Declared in DeviceTree.jadd at line 209


	/* Base class implementation, stop tree traversal at nodes
	 *  that do not override the method. 
	 */
	public Object[] getChildArray() {
		System.out.println("NetworkNode.getChildArray("+this+")");
		return null;	
	}

    // Declared in SelfTest.jadd at line 48

	
//	public void SelfTestService.performSelfTest() {
//		if(hasProxy()) {
//			Command c = (Command) getProxy().findItem(SelfTestProvider.COMMAND_SELFTEST);
//			if(c != null) {
//				System.out.println("SelfTestService.performSelfTest");
//				c.invoke();
//			}
//		}
//	}
	
	private char latestStatus;

    // Declared in SelfTest.jadd at line 49

	private String latestStatusHelpText;

    // Declared in SelfTest.jadd at line 51


	public char getStatus() {return latestStatus;}

    // Declared in SelfTest.jadd at line 52

	public String getStatusHelpText() {return latestStatusHelpText;}

    // Declared in SelfTest.jadd at line 53

	public boolean isNotOK() { return latestStatus == 'R' || latestStatus == 'Y';}

    // Declared in SelfTest.jadd at line 55

	
	public void setLatestStatus(char c) {
		latestStatus = c;
		latestStatusHelpText = "???";
	}

    // Declared in SelfTest.jadd at line 60

	
	public void setLatestStatus(ResourceStatusInfo i) { 
		latestStatus = (char) i.getStatus();
		latestStatusHelpText = i.getHelpText();
	}

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 39

    public NetworkNode() {
        super();


    }

    // Declared in LocalView.ast at line 9


  protected int numChildren() {
    return 0;
  }

    protected java.util.Set isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 122
    public boolean isResource(AbstractResourceAddress a) {
        Object _parameters = a;
        if(isResource_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: isResource in class: ");
        isResource_AbstractResourceAddress_visited.add(_parameters);
        boolean isResource_AbstractResourceAddress_value = isResource_compute(a);
        isResource_AbstractResourceAddress_visited.remove(_parameters);
        return isResource_AbstractResourceAddress_value;
    }

    private boolean isResource_compute(AbstractResourceAddress a) {  return  false;  }

    protected java.util.Set matchesInfo_Info_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 131
    public boolean matchesInfo(Info i) {
        Object _parameters = i;
        if(matchesInfo_Info_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesInfo in class: ");
        matchesInfo_Info_visited.add(_parameters);
        boolean matchesInfo_Info_value = matchesInfo_compute(i);
        matchesInfo_Info_visited.remove(_parameters);
        return matchesInfo_Info_value;
    }

    private boolean matchesInfo_compute(Info i) {  return  false;  }

    protected java.util.Set matches_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 139
    public boolean matches(Object o) {
        Object _parameters = o;
        if(matches_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matches in class: ");
        matches_Object_visited.add(_parameters);
        boolean matches_Object_value = matches_compute(o);
        matches_Object_visited.remove(_parameters);
        return matches_Object_value;
    }

    private boolean matches_compute(Object o) {  return  false;  }

    protected boolean getNumServiceListPart_visited = false;
    // Declared in ServiceRemoval.jrag at line 8
    public int getNumServiceListPart() {
        if(getNumServiceListPart_visited)
            throw new RuntimeException("Circular definition of attr: getNumServiceListPart in class: ");
        getNumServiceListPart_visited = true;
        int getNumServiceListPart_value = getNumServiceListPart_compute();
        getNumServiceListPart_visited = false;
        return getNumServiceListPart_value;
    }

    private int getNumServiceListPart_compute() {  return  0;  }

    protected java.util.Set getServiceListPart_int_visited = new java.util.HashSet(4);
    // Declared in ServiceRemoval.jrag at line 9
    public ServiceListPart getServiceListPart(int i) {
        Object _parameters = new Integer(i);
        if(getServiceListPart_int_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: getServiceListPart in class: ");
        getServiceListPart_int_visited.add(_parameters);
        ServiceListPart getServiceListPart_int_value = getServiceListPart_compute(i);
        getServiceListPart_int_visited.remove(_parameters);
        return getServiceListPart_int_value;
    }

    private ServiceListPart getServiceListPart_compute(int i) {  return  null;  }

    protected java.util.Set lookup_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 60
    public NetworkNode lookup(Object o) {
        Object _parameters = o;
        if(lookup_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookup in class: ");
        lookup_Object_visited.add(_parameters);
        NetworkNode lookup_Object_value = getParent().Define_NetworkNode_lookup(this, null, o);
        lookup_Object_visited.remove(_parameters);
        return lookup_Object_value;
    }

}
