/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;

public class Opt extends ASTNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getErrorList_visited = false;
        getPrettyString_visited = false;
        getIndent_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        Opt node = (Opt)super.clone();
        node.getErrorList_visited = false;
        node.getPrettyString_visited = false;
        node.getIndent_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          Opt node = (Opt)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        Opt res = (Opt)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Hgraph.jadd at line 58


	public void setChild(ASTNode node, int i){
		super.setChild(node, i);
		if((getParent() != null) && (getParent() instanceof PRDData)){
			if(node instanceof PRDData){
				((PRDData)getParent()).removeNodeChild(((PRDData)node).getNodeName(), null);
				((PRDData)getParent()).addNodeChild((PRDData)node, null);
			}else{
				
			}
		}
	}

    // Declared in null at line 3
    // Declared in null line 0

    public Opt() {
        super();


    }

    // Declared in null at line 9


     public Opt(ASTNode opt) {
         setChild(opt, 0);
     }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 56
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute() {  return  getNumChild()!=0?getChild(0).getErrorList():new ArrayList();  }

    protected boolean getPrettyString_visited = false;
    // Declared in PrettyPrint.jrag at line 58
    public String getPrettyString() {
        if(getPrettyString_visited)
            throw new RuntimeException("Circular definition of attr: getPrettyString in class: ");
        getPrettyString_visited = true;
        String getPrettyString_value = getPrettyString_compute();
        getPrettyString_visited = false;
        return getPrettyString_value;
    }

    private String getPrettyString_compute() {  return  "";  }

    protected boolean getIndent_visited = false;
    // Declared in PrettyPrint.jrag at line 59
    public String getIndent() {
        if(getIndent_visited)
            throw new RuntimeException("Circular definition of attr: getIndent in class: ");
        getIndent_visited = true;
        String getIndent_value = getIndent_compute();
        getIndent_visited = false;
        return getIndent_value;
    }

    private String getIndent_compute() {  return  "";  }

}
