/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;

/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

public class PRDAssemblyD extends PRDSecondOrder implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getAssemblyLabel_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        PRDAssemblyD node = (PRDAssemblyD)super.clone();
        node.getAssemblyLabel_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          PRDAssemblyD node = (PRDAssemblyD)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDAssemblyD res = (PRDAssemblyD)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyComparison.jadd at line 37

	public boolean isAboutTheSameEntityAs(PRDData info) {
		System.out.println("Warning! PRDAssemblyD.isAboutTheSameEntityAs only does reference comparison");
		return info==this;
	}

    // Declared in AssemblyTree.jadd at line 69


	public Object[] getChildArray() {
		return getPRDAssemblyVerList().getChildArray();
	}

    // Declared in AssemblyVersioning.jadd at line 51

	
	public PRDAssemblyD(PRDAssemblyVer initialVer) {
		this(initialVer.getFormat(), initialVer.getName(), initialVer.getBaseVersion(), new List());
		addPRDAssemblyVer(initialVer);
	}

    // Declared in AssemblyVersioning.jadd at line 56

	
	public PRDAssemblyD(String format) {
		this();
		setFormat(format);
	}

    // Declared in AssemblyVersioning.jadd at line 113



	
//	private static final int PRDAssemblyD.IDX_creatingURN=0;
//	private static final int PRDAssemblyD.IDX_initialTS=1;
//	private static final int PRDAssemblyD.IDX_parentURN=2;
//	private static final int PRDAssemblyD.IDX_parentTS=3;
//	private static final int PRDAssemblyD.IDX_logicalName=4;
//	private static final int PRDAssemblyD.IDX_updatingURN=5;
//	private static final int PRDAssemblyD.IDX_updatingTS=6;
	
//	public String PRDAssemblyD.getCreatingURN() {
//		return getVersionPart(IDX_creatingURN);
//	}
	
//	public String PRDAssemblyD.getInitialTimestamp() {
//		return getVersionPart(IDX_initialTS);
//	}
	
//	public String PRDAssemblyD.getLogicalVersion() {
//		return getVersionPart(IDX_logicalName);
//	}
	
//	public String PRDAssemblyD.getParentURN() {
//		return getVersionPart(IDX_parentURN);
//	}
	
//	public String PRDAssemblyD.getParentTimestamp() {
//		return getVersionPart(IDX_parentTS);
//	}
	
//	public String PRDAssemblyD.getUpdatingURN() {
//		return getVersionPart(IDX_updatingURN);
//	}
	
//	public String PRDAssemblyD.getUpdatingTimestamp() {
//		return getVersionPart(IDX_updatingTS);
//	}
	
//	public static final String PRDAssemblyD.VERSION_DELIM = ";";
	
	public static String tsStr() {
		return String.valueOf(ist.palcom.base.System.instance().time());
	}

    // Declared in AssemblyVersioning.jadd at line 219


	/** 
	 * Checks if ai and this are versions of the same entity,
	 * i.e., they share a common ancestor.
	 */
	 
	public boolean isRelatedTo(PRDAssemblyVer av) {
		return getBaseVersion().equals(av.getBaseVersion());
	}

    // Declared in AssemblyVersioning.jadd at line 227

	/** 
	 * Checks if ad and this are versions of the same entity,
	 * i.e., they share a common ancestor.
	 */
	 
	public boolean isRelatedTo(PRDAssemblyD ad) {
		return getBaseVersion().equals(ad.getBaseVersion());
	}

    // Declared in AssemblyVersioning.jadd at line 239



	
	/**
	 *  Add a version to the PRDAssemblyD, if it matches previously
	 *  set name/version or name is unset.
	 *
	 *  @return true on sucess
	 */
	public boolean addVersion(PRDAssemblyVer av) {
		if( !getFormat().equals(av.getFormat()) ) {
			throw new IllegalArgumentException("addVersion: Format mismatch");
		}
		
		if(getNumPRDAssemblyVer() > 0) {
			if(getPRDAssemblyVer(0).isRelatedTo(av)) {
				addPRDAssemblyVer(av);
				return true;
			} 
		
		//TODO: what to do for empty PRDAssemblyList?
		// a) add version if base version matches
		// b) always add version and set base version 
		// c) add version and set name/version if name/version unset (current implementation)
		// d) not allowed
			
		} else if( getName()==null || ( "".equals(getName()) ) )  {
			setName(av.getName());
			setBaseVersion(av.getBaseVersion());
			addPRDAssemblyVer(av);
			return true;
		}
		return false;
	}

    // Declared in AssemblyVersioning.jadd at line 280

	
	public boolean isNewVersion(PRDAssemblyVer av) {
		return isRelatedTo(av) && ! hasPRDAssemblyVer(av);
	}

    // Declared in AssemblyVersioning.jadd at line 284

	
	public boolean isUpdate(PRDAssemblyVer av) {
		if(hasPRDAssemblyVer(av)) {
			return false;
		} else {
			for(int i=0; i < getNumPRDAssemblyVer(); i++) {
				PRDAssemblyVer tmp = getPRDAssemblyVer(i);
				if(tmp.isUpdate(av)) {
					return true;
				}
			}
		}
		return false;	
	}

    // Declared in AssemblyVersioning.jadd at line 298

	
	public boolean updateIfNewer(PRDAssemblyVer av) {
		boolean result = isUpdate(av);
		if(result) {
			addVersion(av);
		}
		return result;
	}

    // Declared in AssemblyVersioning.jadd at line 312

	
	/** Aux method, for implementing update/merge. Made public for use
	 *  in the test case (which is why it is marked as deprecated), it
	 *  is really an internal method.
     *
	 *  @deprecated
	 */   
	public boolean hasPRDAssemblyVer(PRDAssemblyVer av) {
		for(int i=0; i < getNumPRDAssemblyVer(); i++) {
			PRDAssemblyVer tmp = getPRDAssemblyVer(i);
			if(av.equals(tmp)) return true;
		}
		return false;
	}

    // Declared in AssemblyVersioning.jadd at line 327

	
	/** Return the set of versions present in ad but not in this
	 *  I.e, ad - this
	 *
	 *  If ad and this do not share the same base version, the result
	 *  is the empty set.
	 */
	
	public java.util.List diffAdded(PRDAssemblyD ad) {
		ArrayList al = new ArrayList();
		//Diff is only applicable to between the "same" assembly
		if(isRelatedTo(ad)) {
			for(int i=0; i < ad.getNumPRDAssemblyVer(); i++) {
				PRDAssemblyVer av = ad.getPRDAssemblyVer(i);
				if(!hasPRDAssemblyVer(av)) {
					al.add(av);
				}
			}
		}
		return al;
	}

    // Declared in AssemblyVersioning.jadd at line 347
	
	
	/** Add each version present in ad not present in this to this
	 *  I.e., after the operation, this will contain the union of the
	 *  versions in ad and this.
     *
	 *  If ad and this do not share the same base version, nothing happens.
	 */
	public void mergeAddedVersionsFrom(PRDAssemblyD ad) {
		java.util.List diff = diffAdded(ad);
		
	   	for (Iterator iter = diff.iterator(); iter.hasNext();) {
			PRDAssemblyVer av = (PRDAssemblyVer) iter.next();
			addVersion(av);
		}
	}

    // Declared in AssemblyXML.jadd at line 38

	
	public void writeAttributes(KXmlSerializer serializer) throws IOException {
        serializer.attribute(null, "format", getFormat());
        serializer.attribute(null, "name", getName());
//        serializer.attribute(null, "version", getVersion());
	}

    // Declared in AssemblyXML.jadd at line 51
		


	public String getTagName() {
		return "PRDAssemblyD";
	}

    // Declared in AssemblyXML.jadd at line 55


    public void initializeFromElement(XmlPullParser parser) {
	    setFormat(parser.getAttributeValue(null, "format"));
        setName(parser.getAttributeValue(null, "name"));
    }

    // Declared in AssemblyXML.jadd at line 60


    public void addChildFromXMLElement(XMLRepresentable child) {    
    	if(child instanceof PRDAssemblyVer) {
    		addPRDAssemblyVer((PRDAssemblyVer)child);
   		} else if(child instanceof VersionPart) {
   			setBaseVersion((VersionPart)child);
   		}
    }

    // Declared in AssemblyXML.jadd at line 67

    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        writeAttributes(serializer);

		getBaseVersion().writeXMLElement(serializer);
		
        for (int i = 0; i < getNumPRDAssemblyVer(); i++) {
            PRDAssemblyVer aInfo = getPRDAssemblyVer(i);
            aInfo.writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 36

    public PRDAssemblyD() {
        super();

        setChild(null, 0);
        setChild(new List(), 1);

    }

    // Declared in Assembly.ast at line 12


    // Declared in Assembly.ast line 36
    public PRDAssemblyD(String p0, String p1, VersionPart p2, List p3) {
        setFormat(p0);
        setName(p1);
        setChild(p2, 0);
        setChild(p3, 1);
    }

    // Declared in Assembly.ast at line 19


  protected int numChildren() {
    return 2;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 36
    private String tokenString_Format;

    // Declared in Assembly.ast at line 3

    public void setFormat(String value) {
        tokenString_Format = value;
    }

    // Declared in Assembly.ast at line 6

    public String getFormat() {
        return tokenString_Format;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 36
    private String tokenString_Name;

    // Declared in Assembly.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in Assembly.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 36
    public void setBaseVersion(VersionPart node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public VersionPart getBaseVersion() {
        return (VersionPart)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public VersionPart getBaseVersionNoTransform() {
        return (VersionPart)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 36
    public void setPRDAssemblyVerList(List list) {
        setChild(list, 1);
    }

    // Declared in Assembly.ast at line 6


    public int getNumPRDAssemblyVer() {
        return getPRDAssemblyVerList().getNumChild();
    }

    // Declared in Assembly.ast at line 10


    public PRDAssemblyVer getPRDAssemblyVer(int i) {
        return (PRDAssemblyVer)getPRDAssemblyVerList().getChild(i);
    }

    // Declared in Assembly.ast at line 14


    public void addPRDAssemblyVer(PRDAssemblyVer node) {
        List list = getPRDAssemblyVerList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in Assembly.ast at line 19


    public void setPRDAssemblyVer(PRDAssemblyVer node, int i) {
        List list = getPRDAssemblyVerList();
        list.setChild(node, i);
    }

    // Declared in Assembly.ast at line 23

    public List getPRDAssemblyVerList() {
        return (List)getChild(1);
    }

    // Declared in Assembly.ast at line 27


    public List getPRDAssemblyVerListNoTransform() {
        return (List)getChildNoTransform(1);
    }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 159
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getName();  }

    // Declared in AssemblyTree.jadd at line 178
    public Service Define_Service_parentService(ASTNode caller, ASTNode child) {
        if(caller == getPRDAssemblyVerListNoTransform()) {
      int childIndex = caller.getIndexOfChild(child);
            return  null;
        }
        return getParent().Define_Service_parentService(this, caller);
    }

}
