/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public class PRDAssemblyVer extends PRDSecondOrder implements Cloneable {
    public void flushCache() {
        super.flushCache();
        lookupVariable_String_visited = new java.util.HashSet(4);
        lookupDevice_DeviceAddress_visited = new java.util.HashSet(4);
        lookupDevice_Identifier_visited = new java.util.HashSet(4);
        lookupService_ServiceAddress_visited = new java.util.HashSet(4);
        lookupService_ServiceUse_visited = new java.util.HashSet(4);
        lookupService_Identifier_visited = new java.util.HashSet(4);
        lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
        lookupConnections_ServiceExp_visited = new java.util.HashSet(4);
        getCustServiceAddr_visited = false;
        getProvServiceAddr_visited = false;
        getParentPRDAssemblyVer_visited = false;
        getAssemblyLabel_visited = false;
        encloseInBraces_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        PRDAssemblyVer node = (PRDAssemblyVer)super.clone();
        node.lookupVariable_String_visited = new java.util.HashSet(4);
        node.lookupDevice_DeviceAddress_visited = new java.util.HashSet(4);
        node.lookupDevice_Identifier_visited = new java.util.HashSet(4);
        node.lookupService_ServiceAddress_visited = new java.util.HashSet(4);
        node.lookupService_ServiceUse_visited = new java.util.HashSet(4);
        node.lookupService_Identifier_visited = new java.util.HashSet(4);
        node.lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
        node.lookupConnections_ServiceExp_visited = new java.util.HashSet(4);
        node.getCustServiceAddr_visited = false;
        node.getProvServiceAddr_visited = false;
        node.getParentPRDAssemblyVer_visited = false;
        node.getAssemblyLabel_visited = false;
        node.encloseInBraces_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          PRDAssemblyVer node = (PRDAssemblyVer)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDAssemblyVer res = (PRDAssemblyVer)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyComparison.jadd at line 41

    public boolean isAboutTheSameEntityAs(PRDData data) {
        if (data == null) {
            return false;
        } else if (data instanceof PRDAssemblyVer) {
            PRDAssemblyVer a = (PRDAssemblyVer) data;
            return a.getName().equals(getName());
        } else {
            return false;
        }
    }

    // Declared in AssemblyComparison.jadd at line 92

//  public boolean PRDAssembly.equals(Object o) {
//  if (!super.equals(o)) {
//      return false;
//  }
//
//  if (o instanceof PRDAssembly) {
//      PRDAssembly a = (PRDAssembly) o;
//      if (!a.getName().equals(getName())) {
//          return false;
//      }
//      if (!(a.getClassName().equals(getClassName()))) {
//          return false;
//      }
//      if (a.getNumConnectionInfo() != getNumConnectionInfo()) {
//          return false;
//      }
//      for (int i = 0; i < getNumConnectionInfo(); i++) {
//          if (!a.getConnectionInfo(i).equals(getConnectionInfo(i))) {
//              return false;
//          }
//      }
//      return true;
//  } else {
//      return false;
//  }
//}

    public int hashCode() {
        return getName().hashCode();
    }

    // Declared in AssemblyNameEditing.jadd at line 54


	public String getIDforEditing() {
		return getName();
	}

    // Declared in AssemblyNameEditing.jadd at line 91

	
	public boolean updateIDfromEditor(String id) {
		if(!getName().equals(id)) {
			setName(id);
			return true;
		}
		return false;
	}

    // Declared in AssemblyScript.jadd at line 77

	
	/* the "this" reference */
//	private ServiceAddress ThisService.sa = new ThisServiceAddress();

	private AbstractResourceAddress custServiceAddr;

    // Declared in AssemblyScript.jadd at line 79

	
	public void setCustServiceAddr(AbstractResourceAddress csa) {
		custServiceAddr = csa;
	}

    // Declared in AssemblyScript.jadd at line 144


	
	private ServiceInstanceID siid;

    // Declared in AssemblyScript.jadd at line 146

	
	private void setSIID(ServiceInstanceID siid) { this.siid = siid;}

    // Declared in AssemblyScript.jadd at line 148

	
	public ServiceInstanceID getSIID() { return siid;}

    // Declared in AssemblyScript.jadd at line 150

	
	public DeviceID getDeviceID() { return siid.getDeviceID();}

    // Declared in AssemblyScript.jadd at line 152

	
	public void setThisReferencesToDeviceID(DeviceContext context) {
		DeviceID did = context.getDeviceInfo().getDeviceID();
		ServiceID sid = null; //XXX get from assembly
		String instanceID = context.getNewInstanceNumber(sid);
		ServiceInstanceID custSiid = new ServiceInstanceID(did,sid,instanceID);
		LocalSID lsid = new LocalSID(did, context.getNewLocalSIDString());
		ServiceAddress assAdr = new ServiceAddress(custSiid, new Opt(), new Opt(lsid));
		setSIID(custSiid);
		setCustServiceAddr(new TemporaryAddress(lsid));

//XXX do we need to separate the customer and provider part?		
//		if(hasPRDServiceFMDescription()) {
//			provURN = getURN().createSubUrn(new URNLeaf(getPRDServiceFMDescription().getID()));
//		}
		
//		for(int i=0; i<getConnections().getNumConnectionDecl();i++) {
//			ConnectionDecl cd = getConnections().getConnectionDecl(i);
//			cd.getProvider().setServiceAddress(assAdr);
//			cd.getCustomer().setServiceAddress(assAdr);
//		}
//		if(hasPRDServiceFMDescription()) {
//
//			if(hasEventHandlerScript()) {
//				EventHandlerList h = getEventHandlerScript().getEventHandlers();
//				for(int i=0; i < h.getNumEventHandlerClause(); i++) {
//					EventHandlerClause ehc = h.getEventHandlerClause(i);
//					ehc.getServiceExp().setServiceAddress(assAdr);
//				}
//				
//				getPRDServiceFMDescription().setLocalSID(lsid);
//			}
//		}
	}

    // Declared in AssemblyScript.jadd at line 186
	
	
	public void setThisReferencesToDeviceID(DeviceID deviceURN) {
		System.err.println("WARNING! PRDAssemblyVer.setThisReferencesToDeviceID broken by changes");
//		URN provURN = new URN("assembly has no provider");
//
////		URN custURN = new URN(deviceURN + "/" + getURNSuffix());
//		URN custURN = deviceURN.createSubUrn(getURNLeaf());
//		setURN(custURN);
//		
//		if(hasPRDServiceFMDescription()) {
////			provURN = new URN(deviceURN + "/" + getPRDServiceFMDescription().getID());
//			provURN = getURN().createSubUrn(new URNLeaf(getPRDServiceFMDescription().getID()));
//		}
//		
//		for(int i=0; i<getConnections().getNumConnectionDecl();i++) {
//			ConnectionDecl cd = getConnections().getConnectionDecl(i);
//			cd.getProvider().setURN(provURN);
//			cd.getCustomer().setURN(custURN);
////			if(ci.getProviderURN().equals("this")) {
////				ci.setProviderURN(provURN);
////			}else if(ci.getCustomerURN().equals("this")) {
////				ci.setCustomerURN(custURN);
////			} 
//////			else if(ci.getProviderURN().equals("this")) {
//////			ci.setProviderURN(deviceURN);
//////			}else if(ci.getCustomerURN().equals("this")) {
//////			ci.setCustomerURN(deviceURN);
//////			}	
//		}
//		if(hasPRDServiceFMDescription()) {
//
//			if(hasEventHandlerScript()) {
//				EventHandlerList h = getEventHandlerScript().getEventHandlers();
//				for(int i=0; i < h.getNumEventHandlerClause(); i++) {
//					EventHandlerClause ehc = h.getEventHandlerClause(i);
//					ehc.getServiceExp().setURN(provURN);
////					String theSrc = ehc.getSenderService();
////					if("thisprovider".equals(ehc.getSenderService())) {
////						ehc.setSenderService(provURN);
////					}
//				}
//				
////				getPRDServiceFMDescription().getProviderURN();
//				//TODO: perhaps replace "this" with "deviceURN" instead, to allow that urnSuffix != ID.
////				getPRDServiceFMDescription().setProviderURN(deviceURN+"/"+getPRDServiceFMDescriptionInfo().getID());
//				getPRDServiceFMDescription().setLocalSID(new LocalSID(provURN.getLeaf().toString()));
//				
//			}
//		}
	}

    // Declared in AssemblyTree.jadd at line 73


	public Object[] getChildArray() {
//		return getConnectionInfoList().getChildArray();
//		return new Object[] {getConnectionInfoList()};
		if(hasEventHandlerScript() && !hasPRDServiceFMDescription()) {
			return new Object[] {getDevices(), getServices(), getConnections(), getEventHandlerScript()};
		} else if (!hasEventHandlerScript() && hasPRDServiceFMDescription()) {
			return new Object[] {getDevices(), getServices(), getConnections(), getPRDServiceFMDescription()};
		} else if (hasEventHandlerScript() && hasPRDServiceFMDescription()) {
			return new Object[] {getDevices(), getServices(), getConnections(), getEventHandlerScript(), getPRDServiceFMDescription()};
		} else {
			return new Object[] {getDevices(), getServices(), getConnections()};
		}
			
	}

    // Declared in AssemblyVersioning.jadd at line 46

	/**
	 *	The PRDAssembly constructor without the version parameters
	 *	is only intended to keep old code compiling. Please update your code.
	 *
	 *  The format field is assigned a default value, "2".
	 *  The version field is assigned a default value, "1".
	 *
	 *@deprecated
	 */
	public PRDAssemblyVer(String p1, DeviceDeclList p2, ServiceDeclList p3, ConnectionDeclList p4, Opt p5, Opt p6) {
//		this("2", p1, "1", false, p2, p3, p4, p5, p6);
		throw new Error("This constructor is deprecated");
	}

    // Declared in AssemblyVersioning.jadd at line 65

	
//	public URNLeaf PRDAssemblyVer.getURNLeaf() {
//		return new URNLeaf(getName()+getUpdatingTimestamp());
//	}
	
	public boolean checkReleasedForEditing() {
		boolean result = getReleased();
		if(result) {
			System.out.println("create new version");
		}
		return result;
	}

    // Declared in AssemblyVersioning.jadd at line 118

	
	
	protected static String tsStr() {
		return String.valueOf(ist.palcom.base.System.instance().time());
	}

    // Declared in AssemblyVersioning.jadd at line 145

	
//	private String PRDAssemblyD.getVersionPart(int idx) {
//		try {
//			String[] split = getVersion().split(VERSION_DELIM);
//			return split[idx];
//		} catch (Exception e) {
//			return "malformed version string";
//		}
//	}
	
//	private String PRDAssemblyVer.getVersionPart(int idx) {
//		try {
//			String[] split = getVersion().split(VERSION_DELIM);
//			return split[idx];
//		} catch (Exception e) {
//			return "malformed version string";
//		}
//	}

//	public String PRDAssemblyD.getBaseVersion() {
//		return getCreatingURN()+VERSION_DELIM+getInitialTimestamp();
//		
//	}

	public VersionPart getBaseVersion() {
//		return getCreatingURN()+VERSION_DELIM+getInitialTimestamp();
		return getVersion().getCreatingVersionPart();
	}

    // Declared in AssemblyVersioning.jadd at line 169

    
    /** Create a new version (full copy).
     *  Sets this version as released;
     */
	public PRDAssemblyVer newVersion(DeviceID did, String logicalVersion) {
		AssemblyID ver = getVersion().createDerivedVersion(did, logicalVersion);
		PRDAssemblyVer copy = (PRDAssemblyVer) fullCopy();
		setReleased(true);
		copy.setReleased(false);
		copy.setVersion(ver);
		return copy;
	}

    // Declared in AssemblyVersioning.jadd at line 178

		
	public PRDAssemblyVer(String format, String name, AssemblyID ver) {
		this(format, name, ver,
		false, new DeviceDeclList(), new ServiceDeclList(), 
		new ConnectionDeclList(), 
		new Opt(), new Opt());
	}

    // Declared in AssemblyVersioning.jadd at line 186

		
	
	public String getLogicalVersion() {
		return getVersion().getLogicalVersion();
	}

    // Declared in AssemblyVersioning.jadd at line 210

	
	/** 
	 * Checks if ai and this are versions of the same entity,
	 * i.e., they share a common ancestor.
	 */
	 
	public boolean isRelatedTo(PRDAssemblyVer av) {
		return getBaseVersion().equals(av.getBaseVersion());
	}

    // Declared in AssemblyVersioning.jadd at line 272

	
	/** 
	 *  Checks if ai is an update to this
     *	
	 *  @return true if this and ai have a common ancestor, and
	 *  it there is a known path in the version tree from
	 *  this to ai. (I.e., the parent version is present)
	 */
	public boolean isUpdate(PRDAssemblyVer av) {
		if(isRelatedTo(av)) {
			return av.getVersion().getPreviousVersionPart().equals(getVersion().getPreviousVersionPart());
		} else {
			return false;
		}
	}

    // Declared in AssemblyXML.jadd at line 44
		

	public void writeAttributes(KXmlSerializer serializer) throws IOException {
        serializer.attribute(null, "format", getFormat());
        serializer.attribute(null, "name", getName());
        serializer.attribute(null, "released", getReleased()?"true":"false");
	}

    // Declared in AssemblyXML.jadd at line 80


    public String getTagName() {
        return "PRDAssemblyVer";
    }

    // Declared in AssemblyXML.jadd at line 84


    public void initializeFromElement(XmlPullParser parser) {
	    setFormat(parser.getAttributeValue(null, "format"));
        setName(parser.getAttributeValue(null, "name"));
        setReleased(Boolean.parseBoolean(parser.getAttributeValue(null,"released")));
        
//        setClassName(parser.getAttributeValue(null, "className"));
//        setActive("true".equals(parser.getAttributeValue(null, "active")));
    }

    // Declared in AssemblyXML.jadd at line 93


    public void addChildFromXMLElement(XMLRepresentable child) {    
    	if(child instanceof ConnectionDecl)
	        getConnections().addConnectionDecl((ConnectionDecl) child);
	    else if (child instanceof DeviceDeclList) 
	    	setDevices((DeviceDeclList)child);
	    else if (child instanceof ServiceDeclList) 
	    	setServices((ServiceDeclList)child);
	    else if (child instanceof ConnectionDeclList) 
	    	setConnections((ConnectionDeclList)child);
	    else if (child instanceof EventHandlerScript)
	    	setEventHandlerScript((EventHandlerScript) child);
	    else if (child instanceof PRDServiceFMDescription)
	    	setPRDServiceFMDescription((PRDServiceFMDescription) child);
	    else if (child instanceof AssemblyID) {
	    	setVersion((AssemblyID)child);
	    } else
	    	System.out.println("PRDAssembly.addChildFromXMLElement: unknown type:"+child);
    }

    // Declared in AssemblyXML.jadd at line 112

    
    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        writeAttributes(serializer);

		getVersion().writeXMLElement(serializer);
		getDevices().writeXMLElement(serializer);
		getServices().writeXMLElement(serializer);
		getConnections().writeXMLElement(serializer);
		if(hasEventHandlerScript())
			getEventHandlerScript().writeXMLElement(serializer);
		if(hasPRDServiceFMDescription())
			getPRDServiceFMDescription().writeXMLElement(serializer);

//        for (int i = 0; i < getConnections().getNumConnectionInfo(); i++) {
//            ConnectionInfo connectionInfo = getConnections().getConnectionInfo(i);
//            connectionInfo.writeXMLElement(serializer);
//        }

        serializer.endTag(null, getTagName());
    }

    // Declared in LabelProviders.jrag at line 229

			
	public String lookupAndFormatAddress(ServiceAddress sa) {
		ServiceDecl asd = lookupService(sa);
		
		if(asd != null && asd.getDecl() instanceof SingleServiceDecl) {
			SingleServiceDecl sd = (SingleServiceDecl) asd.getDecl();
			return sd.getServiceName().getAssemblyLabel() + " on " + sd.getDeviceUse().getAssemblyLabel();
		} else if (asd != null && asd.getDecl() instanceof AltServiceDeclList) {
			AltServiceDeclList asdl = (AltServiceDeclList) asd.getDecl();
			AbstractServiceDecl tmp = asdl.lookupService(sa);
			if(tmp instanceof AltServiceDecl) {
				AltServiceDecl sd = (AltServiceDecl) tmp;
				return sd.getServiceName().getAssemblyLabel() + " on " + sd.getDeviceUse().getAssemblyLabel();				
			}
		}
			
		return sa.toString();
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 38

    public PRDAssemblyVer() {
        super();

        setChild(null, 0);
        setChild(null, 1);
        setChild(null, 2);
        setChild(null, 3);
        setChild(new Opt(), 4);
        setChild(new Opt(), 5);

    }

    // Declared in Assembly.ast at line 16


    // Declared in Assembly.ast line 38
    public PRDAssemblyVer(String p0, String p1, AssemblyID p2, boolean p3, DeviceDeclList p4, ServiceDeclList p5, ConnectionDeclList p6, Opt p7, Opt p8) {
        setFormat(p0);
        setName(p1);
        setChild(p2, 0);
        setReleased(p3);
        setChild(p4, 1);
        setChild(p5, 2);
        setChild(p6, 3);
        setChild(p7, 4);
        setChild(p8, 5);
    }

    // Declared in Assembly.ast at line 28


  protected int numChildren() {
    return 6;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    private String tokenString_Format;

    // Declared in Assembly.ast at line 3

    public void setFormat(String value) {
        tokenString_Format = value;
    }

    // Declared in Assembly.ast at line 6

    public String getFormat() {
        return tokenString_Format;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    private String tokenString_Name;

    // Declared in Assembly.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in Assembly.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    public void setVersion(AssemblyID node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public AssemblyID getVersion() {
        return (AssemblyID)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public AssemblyID getVersionNoTransform() {
        return (AssemblyID)getChildNoTransform(0);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    private boolean tokenboolean_Released;

    // Declared in Assembly.ast at line 3

    public void setReleased(boolean value) {
        tokenboolean_Released = value;
    }

    // Declared in Assembly.ast at line 6

    public boolean getReleased() {
        return tokenboolean_Released;
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    public void setDevices(DeviceDeclList node) {
        setChild(node, 1);
    }

    // Declared in Assembly.ast at line 5

    public DeviceDeclList getDevices() {
        return (DeviceDeclList)getChild(1);
    }

    // Declared in Assembly.ast at line 9


    public DeviceDeclList getDevicesNoTransform() {
        return (DeviceDeclList)getChildNoTransform(1);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    public void setServices(ServiceDeclList node) {
        setChild(node, 2);
    }

    // Declared in Assembly.ast at line 5

    public ServiceDeclList getServices() {
        return (ServiceDeclList)getChild(2);
    }

    // Declared in Assembly.ast at line 9


    public ServiceDeclList getServicesNoTransform() {
        return (ServiceDeclList)getChildNoTransform(2);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    public void setConnections(ConnectionDeclList node) {
        setChild(node, 3);
    }

    // Declared in Assembly.ast at line 5

    public ConnectionDeclList getConnections() {
        return (ConnectionDeclList)getChild(3);
    }

    // Declared in Assembly.ast at line 9


    public ConnectionDeclList getConnectionsNoTransform() {
        return (ConnectionDeclList)getChildNoTransform(3);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    public void setEventHandlerScriptOpt(Opt opt) {
        setChild(opt, 4);
    }

    // Declared in Assembly.ast at line 6


    public boolean hasEventHandlerScript() {
        return getEventHandlerScriptOpt().getNumChild() != 0;
    }

    // Declared in Assembly.ast at line 10


    public EventHandlerScript getEventHandlerScript() {
        return (EventHandlerScript)getEventHandlerScriptOpt().getChild(0);
    }

    // Declared in Assembly.ast at line 14


    public void setEventHandlerScript(EventHandlerScript node) {
        getEventHandlerScriptOpt().setChild(node, 0);
    }

    // Declared in Assembly.ast at line 17

    public Opt getEventHandlerScriptOpt() {
        return (Opt)getChild(4);
    }

    // Declared in Assembly.ast at line 21


    public Opt getEventHandlerScriptOptNoTransform() {
        return (Opt)getChildNoTransform(4);
    }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 38
    public void setPRDServiceFMDescriptionOpt(Opt opt) {
        setChild(opt, 5);
    }

    // Declared in Assembly.ast at line 6


    public boolean hasPRDServiceFMDescription() {
        return getPRDServiceFMDescriptionOpt().getNumChild() != 0;
    }

    // Declared in Assembly.ast at line 10


    public PRDServiceFMDescription getPRDServiceFMDescription() {
        return (PRDServiceFMDescription)getPRDServiceFMDescriptionOpt().getChild(0);
    }

    // Declared in Assembly.ast at line 14


    public void setPRDServiceFMDescription(PRDServiceFMDescription node) {
        getPRDServiceFMDescriptionOpt().setChild(node, 0);
    }

    // Declared in Assembly.ast at line 17

    public Opt getPRDServiceFMDescriptionOpt() {
        return (Opt)getChild(5);
    }

    // Declared in Assembly.ast at line 21


    public Opt getPRDServiceFMDescriptionOptNoTransform() {
        return (Opt)getChildNoTransform(5);
    }

    protected java.util.Set lookupVariable_String_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 39
    public VariableDecl lookupVariable(String name) {
        Object _parameters = name;
        if(lookupVariable_String_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupVariable in class: ");
        lookupVariable_String_visited.add(_parameters);
        VariableDecl lookupVariable_String_value = lookupVariable_compute(name);
        lookupVariable_String_visited.remove(_parameters);
        return lookupVariable_String_value;
    }

    private VariableDecl lookupVariable_compute(String name) {  return  hasEventHandlerScript() ?
            getEventHandlerScript().lookupVariable(name) : null;  }

    protected java.util.Set lookupDevice_DeviceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 60
    public DeviceDecl lookupDevice(DeviceAddress did) {
        Object _parameters = did;
        if(lookupDevice_DeviceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupDevice in class: ");
        lookupDevice_DeviceAddress_visited.add(_parameters);
        DeviceDecl lookupDevice_DeviceAddress_value = lookupDevice_compute(did);
        lookupDevice_DeviceAddress_visited.remove(_parameters);
        return lookupDevice_DeviceAddress_value;
    }

    private DeviceDecl lookupDevice_compute(DeviceAddress did) {  return  getDevices().lookupDevice(did);  }

    protected java.util.Set lookupDevice_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 80
    public DeviceDecl lookupDevice(Identifier id) {
        Object _parameters = id;
        if(lookupDevice_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupDevice in class: ");
        lookupDevice_Identifier_visited.add(_parameters);
        DeviceDecl lookupDevice_Identifier_value = lookupDevice_compute(id);
        lookupDevice_Identifier_visited.remove(_parameters);
        return lookupDevice_Identifier_value;
    }

    private DeviceDecl lookupDevice_compute(Identifier id) {  return  getDevices().lookupDevice(id);  }

    protected java.util.Set lookupService_ServiceAddress_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 101
    public ServiceDecl lookupService(ServiceAddress sa) {
        Object _parameters = sa;
        if(lookupService_ServiceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_ServiceAddress_visited.add(_parameters);
        ServiceDecl lookupService_ServiceAddress_value = lookupService_compute(sa);
        lookupService_ServiceAddress_visited.remove(_parameters);
        return lookupService_ServiceAddress_value;
    }

    private ServiceDecl lookupService_compute(ServiceAddress sa) {  return  getServices().lookupService(sa);  }

    protected java.util.Set lookupService_ServiceUse_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 180
    public ServiceDecl lookupService(ServiceUse su) {
        Object _parameters = su;
        if(lookupService_ServiceUse_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_ServiceUse_visited.add(_parameters);
        ServiceDecl lookupService_ServiceUse_value = lookupService_compute(su);
        lookupService_ServiceUse_visited.remove(_parameters);
        return lookupService_ServiceUse_value;
    }

    private ServiceDecl lookupService_compute(ServiceUse su) {  return  getServices().lookupService(su.getIdentifier());  }

    protected java.util.Set lookupService_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 183
    public ServiceDecl lookupService(Identifier id) {
        Object _parameters = id;
        if(lookupService_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupService in class: ");
        lookupService_Identifier_visited.add(_parameters);
        ServiceDecl lookupService_Identifier_value = lookupService_compute(id);
        lookupService_Identifier_visited.remove(_parameters);
        return lookupService_Identifier_value;
    }

    private ServiceDecl lookupService_compute(Identifier id) {  return  getServices().lookupService(id);  }

    protected java.util.Set lookupConnection_ServiceExp_ServiceExp_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 315
    public ConnectionDecl lookupConnection(ServiceExp cust, ServiceExp prov) {
        java.util.List _parameters = new java.util.ArrayList(2);
        _parameters.add(cust);
        _parameters.add(prov);
        if(lookupConnection_ServiceExp_ServiceExp_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupConnection in class: ");
        lookupConnection_ServiceExp_ServiceExp_visited.add(_parameters);
        ConnectionDecl lookupConnection_ServiceExp_ServiceExp_value = lookupConnection_compute(cust, prov);
        lookupConnection_ServiceExp_ServiceExp_visited.remove(_parameters);
        return lookupConnection_ServiceExp_ServiceExp_value;
    }

    private ConnectionDecl lookupConnection_compute(ServiceExp cust, ServiceExp prov) {  return  getConnections().lookupConnection(cust,prov);  }

    protected java.util.Set lookupConnections_ServiceExp_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 336
    public ArrayList lookupConnections(ServiceExp svc) {
        Object _parameters = svc;
        if(lookupConnections_ServiceExp_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: lookupConnections in class: ");
        lookupConnections_ServiceExp_visited.add(_parameters);
        ArrayList lookupConnections_ServiceExp_value = lookupConnections_compute(svc);
        lookupConnections_ServiceExp_visited.remove(_parameters);
        return lookupConnections_ServiceExp_value;
    }

    private ArrayList lookupConnections_compute(ServiceExp svc) {  return  getConnections().lookupConnections(svc);  }

    protected boolean getCustServiceAddr_visited = false;
    // Declared in AssemblyScript.jadd at line 83
    public AbstractResourceAddress getCustServiceAddr() {
        if(getCustServiceAddr_visited)
            throw new RuntimeException("Circular definition of attr: getCustServiceAddr in class: ");
        getCustServiceAddr_visited = true;
        AbstractResourceAddress getCustServiceAddr_value = getCustServiceAddr_compute();
        getCustServiceAddr_visited = false;
        return getCustServiceAddr_value;
    }

    private AbstractResourceAddress getCustServiceAddr_compute() {  return  custServiceAddr;  }

    protected boolean getProvServiceAddr_visited = false;
    // Declared in AssemblyScript.jadd at line 84
    public AbstractResourceAddress getProvServiceAddr() {
        if(getProvServiceAddr_visited)
            throw new RuntimeException("Circular definition of attr: getProvServiceAddr in class: ");
        getProvServiceAddr_visited = true;
        AbstractResourceAddress getProvServiceAddr_value = getProvServiceAddr_compute();
        getProvServiceAddr_visited = false;
        return getProvServiceAddr_value;
    }

    private AbstractResourceAddress getProvServiceAddr_compute()  {
		if(hasPRDServiceFMDescription()) {
			return new TemporaryAddress(getPRDServiceFMDescription().getLocalSID());
		} 
		return null;
	}

    protected boolean getParentPRDAssemblyVer_visited = false;
/** This is a hack used for the released flag check. 
	 *  (as ASTNode cannot inherit ai())
	 * @return the PRDAssemblyVer at the root of the tree or null
	 
    Declared in AssemblyVersioning.jadd at line 203
*/
    public PRDAssemblyVer getParentPRDAssemblyVer() {
        if(getParentPRDAssemblyVer_visited)
            throw new RuntimeException("Circular definition of attr: getParentPRDAssemblyVer in class: ");
        getParentPRDAssemblyVer_visited = true;
        PRDAssemblyVer getParentPRDAssemblyVer_value = getParentPRDAssemblyVer_compute();
        getParentPRDAssemblyVer_visited = false;
        return getParentPRDAssemblyVer_value;
    }

    private PRDAssemblyVer getParentPRDAssemblyVer_compute() {  return  this;  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 161
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getName() + " " + getLogicalVersion() + (getReleased()?" [released]":"");  }

    protected boolean encloseInBraces_visited = false;
    // Declared in PrettyPrint.jrag at line 67
    public boolean encloseInBraces() {
        if(encloseInBraces_visited)
            throw new RuntimeException("Circular definition of attr: encloseInBraces in class: ");
        encloseInBraces_visited = true;
        boolean encloseInBraces_value = encloseInBraces_compute();
        encloseInBraces_visited = false;
        return encloseInBraces_value;
    }

    private boolean encloseInBraces_compute() {  return  true;  }

    // Declared in AssemblyScript.jadd at line 93
    public AbstractResourceAddress Define_AbstractResourceAddress_custServiceAddress(ASTNode caller, ASTNode child) {
        if(caller == getPRDServiceFMDescriptionOptNoTransform()) {
            return  getCustServiceAddr();
        }
        if(caller == getEventHandlerScriptOptNoTransform()) {
            return  getCustServiceAddr();
        }
        if(caller == getConnectionsNoTransform()) {
            return  getCustServiceAddr();
        }
        return getParent().Define_AbstractResourceAddress_custServiceAddress(this, caller);
    }

    // Declared in AssemblyTree.jadd at line 45
    public PRDAssemblyVer Define_PRDAssemblyVer_av(ASTNode caller, ASTNode child) {
        if(caller == getEventHandlerScriptOptNoTransform()) {
            return  this;
        }
        if(caller == getConnectionsNoTransform()) {
            return  this;
        }
        if(caller == getServicesNoTransform()) {
            return  this;
        }
        if(caller == getDevicesNoTransform()) {
            return  this;
        }
        return getParent().Define_PRDAssemblyVer_av(this, caller);
    }

    // Declared in AssemblyScript.jadd at line 96
    public AbstractResourceAddress Define_AbstractResourceAddress_provServiceAddress(ASTNode caller, ASTNode child) {
        if(caller == getPRDServiceFMDescriptionOptNoTransform()) {
            return  getProvServiceAddr();
        }
        if(caller == getEventHandlerScriptOptNoTransform()) {
            return  getProvServiceAddr();
        }
        if(caller == getConnectionsNoTransform()) {
            return  getProvServiceAddr();
        }
        return getParent().Define_AbstractResourceAddress_provServiceAddress(this, caller);
    }

}
