/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


			
public class PRDConnection extends PRDSecondOrder implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        PRDConnection node = (PRDConnection)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          PRDConnection node = (PRDConnection)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDConnection res = (PRDConnection)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyTree.jadd at line 117

	
	public Object[] getChildArray() {
//		return new Object[] {getProviderURN(), getCustomerURN()};
		String provD = getLocalSID1().getDeviceID().toString();
//		String provS = getProviderURN().substring(provD.length()+1);
		String provS = getLocalSID1().getServicePartID();
		String custD = getLocalSID2().getDeviceID().toString();
//		String custS = getCustomerURN().substring(custD.length()+1);
		String custS = getLocalSID2().getServicePartID();
		return new Object[] {new String(provS +" on " +provD), new String(custS +" on "+custD)};
	}

    // Declared in Comparison.jadd at line 162


    public boolean isAboutTheSameEntityAs(PRDData data) {
        if (data == null) {
            return false;
        } else if (data instanceof PRDConnection) {
            PRDConnection c = (PRDConnection) data;
            return (c.getLocalSID1().equals(getLocalSID1()) 
            	&& c.getLocalSID2().equals(getLocalSID2())) 
            	|| (c.getLocalSID1().equals(getLocalSID2()) 
            	&& c.getLocalSID2().equals(getLocalSID1()));
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 176


    public boolean equals(Object o) {
        if (o instanceof PRDConnection) {
            PRDConnection c = (PRDConnection) o;
            if(c.getLocalSID1().equals(getLocalSID1()) 
            	&& c.getLocalSID2().equals(getLocalSID2())) {
            	return true;
            } else if(c.getLocalSID2().equals(getLocalSID1()) 
            	&& c.getLocalSID1().equals(getLocalSID2())) {
            	return true;
            }
        }
        return false;
    }

    // Declared in Comparison.jadd at line 190


    public int hashCode() {
        return (getLocalSID1().toString() + getLocalSID2().toString()).hashCode();
    }

    // Declared in Info.jadd at line 85


    public DeviceID getDeviceID() {
        if (getLocalSID2() == null) {
            return null;
        } else if(getLocalSID2().getDeviceID() == null) {
        	return null;
        } else {
            return getLocalSID2().getDeviceID();
        }
    }

    // Declared in PRD.jadd at line 48

    
    public PRDConnection(LocalSID providerLocalSID, 
    		LocalSID customerLocalSID){
    	this(providerLocalSID.toString() + 
    		" <->>" + customerLocalSID.toString(),providerLocalSID, customerLocalSID);
    }

    // Declared in XML.jadd at line 85


    public String getTagName() {
        return "C";
    }

    // Declared in XML.jadd at line 227

	
    public void initializeFromElement(XmlPullParser parser) {
       	super.initializeFromElement(parser);
        setLocalSID1(new LocalSID(new DeviceID(parser.getAttributeValue(null, "pdid1")), 
        	parser.getAttributeValue(null, "lsid1")));
        setLocalSID2(new LocalSID(null, parser.getAttributeValue(null, "lsid2")));
    }

    // Declared in XML.jadd at line 533


    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        super.writeAttributes(serializer);
        if(getLocalSID1() != null && getLocalSID1().getDeviceID() != null) {
        	serializer.attribute(null, "pdid1", getLocalSID1().getDeviceID().toString());
        }
        if(getLocalSID1() != null && getLocalSID1().getServicePartID() != null) {
        	serializer.attribute(null, "lsid1", getLocalSID1().getServicePartID());
        }
        if(getLocalSID2() != null && getLocalSID2().getServicePartID() != null) {
        	serializer.attribute(null, "lsid2", getLocalSID2().getServicePartID());
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 61

    public void refined_PalcomResourceDescriptor_PRDConnection() {

        setChild(null, 0);
        setChild(null, 1);

    }

    // Declared in PalcomResourceDescriptor.ast at line 12


    // Declared in PalcomResourceDescriptor.ast line 61
    public PRDConnection(String p0, LocalSID p1, LocalSID p2) {
        setName(p0);
        setChild(p1, 0);
        setChild(p2, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 18


  protected int numChildren() {
    return 2;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 40
    private String tokenString_Name;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void refined_PalcomResourceDescriptor_setName(String value) {
        tokenString_Name = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 61
    public void setLocalSID1(LocalSID node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public LocalSID getLocalSID1() {
        return (LocalSID)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public LocalSID getLocalSID1NoTransform() {
        return (LocalSID)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 61
    public void setLocalSID2(LocalSID node) {
        setChild(node, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public LocalSID getLocalSID2() {
        return (LocalSID)getChild(1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public LocalSID getLocalSID2NoTransform() {
        return (LocalSID)getChildNoTransform(1);
    }

    // Declared in Hgraph.jadd at line 139


	  public PRDConnection() {
		refined_PalcomResourceDescriptor_PRDConnection();
		_node.setNodeName("PRDConnection", null);
}


    // Declared in Hgraph.jadd at line 144

	
	  public void setName(String name){
		refined_PalcomResourceDescriptor_setName(name);
		if(name != null){
			int i = _node.setNodeName(getTagName() + " - " + name, null);
			if(i != IHgraphNode.STATUS_OK){
				System.out.println("Could not set node name: " + name + " , errcode: " + i);
			}else{
				_node.getValueFunc().setValue("name", name, null);
			}		
		}
	}

}
