/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


			
public class PRDDeviceReply extends Reply implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        PRDDeviceReply node = (PRDDeviceReply)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          PRDDeviceReply node = (PRDDeviceReply)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDDeviceReply res = (PRDDeviceReply)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in XML.jadd at line 156

	
	public String getTagName() {
		return "DA";
	}

    // Declared in XML.jadd at line 374

	
	public void initializeFromElement(XmlPullParser parser) {
		setServiceCache(parser.getAttributeValue(null, "svc"));
		setConnectionCache(parser.getAttributeValue(null, "cc"));
		setAssemblyCache(parser.getAttributeValue(null, "ac"));
		setSelectorCache(parser.getAttributeValue(null, "slc"));
		setServiceStatusCache(parser.getAttributeValue(null, "ssc"));
	}

    // Declared in XML.jadd at line 479

    
    public void addChildFromXMLElement(XMLRepresentable child){
		if(child instanceof PRDDevice){
			setPRDDevice((PRDDevice)child);
		}    
    }

    // Declared in XML.jadd at line 719

	
	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
		serializer.startTag(null, getTagName());
		serializer.attribute(null, "svc", getServiceCache());
		serializer.attribute(null, "cc", getConnectionCache());
		serializer.attribute(null, "ac", getAssemblyCache());
		serializer.attribute(null, "slc", getSelectorCache());
		serializer.attribute(null, "ssc", getServiceStatusCache());
		if(getPRDDevice() != null) {
			getPRDDevice().writeXMLElement(serializer);
		}
		serializer.endTag(null, getTagName());
	}

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 102

    public PRDDeviceReply() {
        super();

        setChild(null, 0);

    }

    // Declared in PalcomResourceDescriptor.ast at line 11


    // Declared in PalcomResourceDescriptor.ast line 102
    public PRDDeviceReply(String p0, String p1, String p2, String p3, String p4, PRDDevice p5) {
        setServiceCache(p0);
        setConnectionCache(p1);
        setAssemblyCache(p2);
        setSelectorCache(p3);
        setServiceStatusCache(p4);
        setChild(p5, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 20


  protected int numChildren() {
    return 1;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 102
    private String tokenString_ServiceCache;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setServiceCache(String value) {
        tokenString_ServiceCache = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getServiceCache() {
        return tokenString_ServiceCache;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 102
    private String tokenString_ConnectionCache;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setConnectionCache(String value) {
        tokenString_ConnectionCache = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getConnectionCache() {
        return tokenString_ConnectionCache;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 102
    private String tokenString_AssemblyCache;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setAssemblyCache(String value) {
        tokenString_AssemblyCache = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getAssemblyCache() {
        return tokenString_AssemblyCache;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 102
    private String tokenString_SelectorCache;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setSelectorCache(String value) {
        tokenString_SelectorCache = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getSelectorCache() {
        return tokenString_SelectorCache;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 102
    private String tokenString_ServiceStatusCache;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setServiceStatusCache(String value) {
        tokenString_ServiceStatusCache = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getServiceStatusCache() {
        return tokenString_ServiceStatusCache;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 102
    public void setPRDDevice(PRDDevice node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public PRDDevice getPRDDevice() {
        return (PRDDevice)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public PRDDevice getPRDDeviceNoTransform() {
        return (PRDDevice)getChildNoTransform(0);
    }

}
