/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public class PRDServiceFMDescription extends GroupInfo implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getAssemblyLabel_visited = false;
        getPrettyString_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        PRDServiceFMDescription node = (PRDServiceFMDescription)super.clone();
        node.getAssemblyLabel_visited = false;
        node.getPrettyString_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          PRDServiceFMDescription node = (PRDServiceFMDescription)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDServiceFMDescription res = (PRDServiceFMDescription)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyNameEditing.jadd at line 78


	public String getIDforEditing() {
		return getID();
	}

    // Declared in ServiceDescription.jadd at line 115

    
    public PRDServiceFMDescription(String id) {
        this(id, null, null, new List());
    }

    // Declared in ServiceDescription.jadd at line 632

    
    public ControlItem createInstance() {
        ServiceProxy instance = new ServiceProxy(this, new List());
        for (int i = 0; i < getNumControlInfo(); i++) {
            instance.addControlItem(getControlInfo(i).createInstance());
        }
        return instance;
    }

    // Declared in Comparison.jadd at line 268


    public boolean isAboutTheSameEntityAs(PRDData data) {
        if (data == null) {
            return false;
        } else if (data instanceof PRDServiceFMDescription) {
            PRDServiceFMDescription sd = (PRDServiceFMDescription) data;
            return (PRDData.safeEqual(sd.getLocalSID(), getLocalSID()));
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 512


    public boolean equals(Object o) {
        if (!super.equals(o)) {
            return false;
        }

        if (o instanceof PRDServiceFMDescription) {
            PRDServiceFMDescription sd = (PRDServiceFMDescription) o;
            if (!PRDData.safeEqual(sd.getLocalSID(), getLocalSID())) {
                return false;
            }
            return true;
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 594

    
    public int hashCode() {
    	try {
	        return (getLocalSID().getDeviceID() + getLocalSID().getServicePartID() + getID()).hashCode();
	    } catch (NullPointerException e) {
	    	System.err.println("Warning! PRDServiceFMDescription.hashCode caught NullPointerException");
	    	return super.hashCode();
	    }
    }

    // Declared in XML.jadd at line 132


    public String getTagName() {
        return "SD";
    }

    // Declared in XML.jadd at line 338


    public void initializeFromElement(XmlPullParser parser) {
        setID(parser.getAttributeValue(null, "id"));
        setHelp(parser.getAttributeValue(null, "help"));
        setLocalSID(new LocalSID(null, parser.getAttributeValue(null, "ls")));
    }

    // Declared in XML.jadd at line 440

    
    public void addChildFromXMLElement(XMLRepresentable child){
		if(child instanceof ControlInfo){
			addControlInfo((ControlInfo)child);
		}    
    }

    // Declared in XML.jadd at line 634


    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        writeStartTagAndAttributes(serializer);
        for (int i = 0; i < getNumControlInfo(); i++) {
            getControlInfo(i).writeXMLElement(serializer);
        }
        serializer.endTag(null, getTagName());
    }

    // Declared in XML.jadd at line 877


    protected void writeStartTagAndAttributes(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        if (getID() != null) {
            serializer.attribute(null, "id", getID());
        }
        if (getHelp() != null) {
            serializer.attribute(null, "help", getHelp());
        }
        if(getLocalSID() != null && getLocalSID().getServicePartID() != null) {
			serializer.attribute(null, "ls", getLocalSID().getServicePartID());
		}
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 66

    public PRDServiceFMDescription() {
        super();

        setChild(null, 0);
        setChild(new List(), 1);

    }

    // Declared in PalcomResourceDescriptor.ast at line 12


    // Declared in PalcomResourceDescriptor.ast line 66
    public PRDServiceFMDescription(String p0, String p1, LocalSID p2, List p3) {
        setID(p0);
        setHelp(p1);
        setChild(p2, 0);
        setChild(p3, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 19


  protected int numChildren() {
    return 2;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 69
    private String tokenString_ID;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void refined_PalcomResourceDescriptor_setID(String value) {
        tokenString_ID = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getID() {
        return tokenString_ID;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 69
    private String tokenString_Help;

    // Declared in PalcomResourceDescriptor.ast at line 3

    public void setHelp(String value) {
        tokenString_Help = value;
    }

    // Declared in PalcomResourceDescriptor.ast at line 6

    public String getHelp() {
        return tokenString_Help;
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 66
    public void refined_PalcomResourceDescriptor_setLocalSID(LocalSID node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public LocalSID getLocalSID() {
        return (LocalSID)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public LocalSID getLocalSIDNoTransform() {
        return (LocalSID)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 66
    public void setControlInfoList(List list) {
        setChild(list, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 6


    public int getNumControlInfo() {
        return getControlInfoList().getNumChild();
    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    public ControlInfo getControlInfo(int i) {
        return (ControlInfo)getControlInfoList().getChild(i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 14


    public void addControlInfo(ControlInfo node) {
        List list = getControlInfoList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in PalcomResourceDescriptor.ast at line 19


    public void setControlInfo(ControlInfo node, int i) {
        List list = getControlInfoList();
        list.setChild(node, i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 23

    public List getControlInfoList() {
        return (List)getChild(1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 27


    public List getControlInfoListNoTransform() {
        return (List)getChildNoTransform(1);
    }

    // Declared in Hgraph.jadd at line 46

	
	  public void setID(String ID){
		refined_PalcomResourceDescriptor_setID(ID);
		if(ID != null){
			_node.getValueFunc().setValue("id", ID, null);		
			_node.setNodeName(getTagName() + " - " + ID, null);
		}
	}

    // Declared in Hgraph.jadd at line 54

	
	  public void setLocalSID(LocalSID localSID){
		refined_PalcomResourceDescriptor_setLocalSID(localSID);
		if(localSID != null){
			_node.getValueFunc().setValue("localSID", localSID, null);		
		}
	}

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 221
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute()  {
		if(getID()!=null) {
			return getID();
		} else {
			return super.getAssemblyLabel();
		}
	}

    protected boolean getPrettyString_visited = false;
    // Declared in PrettyPrint.jrag at line 80
    public String getPrettyString() {
        if(getPrettyString_visited)
            throw new RuntimeException("Circular definition of attr: getPrettyString in class: ");
        getPrettyString_visited = true;
        String getPrettyString_value = getPrettyString_compute();
        getPrettyString_visited = false;
        return getPrettyString_value;
    }

    private String getPrettyString_compute() {  return  "Synthesized Service: "+super.getPrettyString();  }

}
