/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public class PRDServiceList extends PRDSecondOrderList implements Cloneable {
    public void flushCache() {
        super.flushCache();
    }
    public Object clone() throws CloneNotSupportedException {
        PRDServiceList node = (PRDServiceList)super.clone();
    return node;
    }
    public ASTNode copy() {
      try {
          PRDServiceList node = (PRDServiceList)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        PRDServiceList res = (PRDServiceList)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Info.jadd at line 47

    
    public PRDServiceList(LocalSID parentLocalSID) {
    	this();
    	setParentLocalSID(parentLocalSID);
    }

    // Declared in Info.jadd at line 69

    
    public PRDServiceListItem getPRDServiceListItem(LocalSID localSID) {
        for (int i = 0; i < getNumPRDServiceListItem(); i++) {
        	PRDServiceListItem listItem = (PRDServiceListItem)getPRDServiceListItem(i);
           	 if (localSID.equals(listItem.getLocalSID())) {
               	return listItem;
            }
        }
        return null;
    }

    // Declared in Comparison.jadd at line 203


    public boolean isAboutTheSameEntityAs(PRDData data) {
        if (data == null) {
            return false;
        } else if (data instanceof PRDServiceList) {
            PRDServiceList sl = (PRDServiceList) data;
            return (PRDData.safeEqual(sl.getParentLocalSID(), getParentLocalSID()));
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 291



    public PRDData getPRDDataThatEquals(PRDData data) {
        PRDData anPRDData = super.getPRDDataThatEquals(data);
        if (anPRDData != null) {
            return anPRDData;
        }
        for (int i = 0; i < getNumPRDServiceListItem(); i++) {
            anPRDData = getPRDServiceListItem(i).getPRDDataThatEquals(data);
            if (anPRDData != null) {
                return data;
            }
        }
        return null;
    }

    // Declared in Comparison.jadd at line 305


    public PRDData getPRDDataThatIsAboutTheSameEntityAs(PRDData data) {
        PRDData anPRDData = super.getPRDDataThatIsAboutTheSameEntityAs(data);
        if (anPRDData != null) {
            return anPRDData;
        }
        for (int i = 0; i < getNumPRDServiceListItem(); i++) {
            anPRDData = getPRDServiceListItem(i).getPRDDataThatIsAboutTheSameEntityAs(data);
            if (anPRDData != null) {
                return data;
            }
        }
        return null;
    }

    // Declared in Comparison.jadd at line 349


    public boolean equals(Object o) {
        if (o instanceof PRDServiceList) {
            PRDServiceList sl = (PRDServiceList) o;
            if ((sl.getParentLocalSID() != null && getParentLocalSID() == null) ||
            		(sl.getParentLocalSID() == null && getParentLocalSID() != null)) {
                return false;
            }
            if ((sl.getParentLocalSID() != null && getParentLocalSID() != null) && !sl.getParentLocalSID().equals(getParentLocalSID())) {
                return false;
            }
            if (sl.getNumPRDServiceListItem() != getNumPRDServiceListItem()) {
                return false;
            }
            for (int i = 0; i < getNumPRDServiceListItem(); i++) {
                if (!sl.getPRDServiceListItem(i).equals(getPRDServiceListItem(i))) {
                    return false;
                }
            }
            return true;
        } else {
            return false;
        }
    }

    // Declared in Comparison.jadd at line 571


    public int hashCode() {
        return getParentLocalSID().toString().hashCode();
    }

    // Declared in Info.jadd at line 62

    
    public LocalSID getLocalSID() {
    	return getParentLocalSID();
    }

    // Declared in PRD.jadd at line 38


    public void addPRDService(PRDService node) {
        List list = getPRDServiceListItemList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in PRD.jadd at line 43

    
    public void addPRDSubList(PRDSubList node) {
        List list = getPRDServiceListItemList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in XML.jadd at line 93


    public String getTagName() {
        return "SL";
    }

    // Declared in XML.jadd at line 281

    
    public void initializeFromElement(XmlPullParser parser) {
        String parentLocalSID = parser.getAttributeValue(null, "ls");
        if(parentLocalSID != null) {
        	setParentLocalSID(new LocalSID(null, parentLocalSID));
        }
    }

    // Declared in XML.jadd at line 446

    
    public void addChildFromXMLElement(XMLRepresentable child) {
        if (child instanceof PRDService) {
            addPRDService((PRDService) child);
        } else if(child instanceof PRDSubList) {
        	addPRDSubList((PRDSubList) child);
        }
    }

    // Declared in XML.jadd at line 568


    public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());

        if(getParentLocalSID() != null && getParentLocalSID().getServicePartID() != null) {
        	serializer.attribute(null, "ls", getParentLocalSID().getServicePartID());
        }

        for (int i = 0; i < getNumPRDServiceListItem(); i++) {
            getPRDServiceListItem(i).writeXMLElement(serializer);
        }

        serializer.endTag(null, getTagName());
    }

    // Declared in PalcomResourceDescriptor.ast at line 3
    // Declared in PalcomResourceDescriptor.ast line 63

    public void refined_PalcomResourceDescriptor_PRDServiceList() {

        setChild(null, 0);
        setChild(new List(), 1);

    }

    // Declared in PalcomResourceDescriptor.ast at line 12


    // Declared in PalcomResourceDescriptor.ast line 63
    public PRDServiceList(LocalSID p0, List p1) {
        setChild(p0, 0);
        setChild(p1, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 17


  protected int numChildren() {
    return 2;
  }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 63
    public void refined_PalcomResourceDescriptor_setParentLocalSID(LocalSID node) {
        setChild(node, 0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 5

    public LocalSID getParentLocalSID() {
        return (LocalSID)getChild(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 9


    public LocalSID getParentLocalSIDNoTransform() {
        return (LocalSID)getChildNoTransform(0);
    }

    // Declared in PalcomResourceDescriptor.ast at line 2
    // Declared in PalcomResourceDescriptor.ast line 63
    public void setPRDServiceListItemList(List list) {
        setChild(list, 1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 6


    public int getNumPRDServiceListItem() {
        return getPRDServiceListItemList().getNumChild();
    }

    // Declared in PalcomResourceDescriptor.ast at line 10


    public PRDServiceListItem getPRDServiceListItem(int i) {
        return (PRDServiceListItem)getPRDServiceListItemList().getChild(i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 14


    public void addPRDServiceListItem(PRDServiceListItem node) {
        List list = getPRDServiceListItemList();
        list.setChild(node, list.getNumChild());
    }

    // Declared in PalcomResourceDescriptor.ast at line 19


    public void setPRDServiceListItem(PRDServiceListItem node, int i) {
        List list = getPRDServiceListItemList();
        list.setChild(node, i);
    }

    // Declared in PalcomResourceDescriptor.ast at line 23

    public List getPRDServiceListItemList() {
        return (List)getChild(1);
    }

    // Declared in PalcomResourceDescriptor.ast at line 27


    public List getPRDServiceListItemListNoTransform() {
        return (List)getChildNoTransform(1);
    }

    // Declared in Hgraph.jadd at line 196

	
	  public PRDServiceList() {
		refined_PalcomResourceDescriptor_PRDServiceList();
		_node.setNodeName("PRDServiceList", null);
}


    // Declared in Hgraph.jadd at line 201

	    
      public void setParentLocalSID(LocalSID parentLocalSID){
    	refined_PalcomResourceDescriptor_setParentLocalSID(parentLocalSID);
   		if(getParentLocalSID() != null){
			_node.getValueFunc().setValue("localSID", getParentLocalSID(), null);		
		}
    }

}
