/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public abstract class Service extends ServiceListPart implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getServiceInfoListItem_visited = false;
        getBrowserLabel_visited = false;
        localLookup_Object_visited = new java.util.HashSet(4);
        isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
        matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        matchesInfo_Info_visited = new java.util.HashSet(4);
        getName_visited = false;
        getAddress_visited = false;
        universe_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        Service node = (Service)super.clone();
        node.getServiceInfoListItem_visited = false;
        node.getBrowserLabel_visited = false;
        node.localLookup_Object_visited = new java.util.HashSet(4);
        node.isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
        node.matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        node.matchesInfo_Info_visited = new java.util.HashSet(4);
        node.getName_visited = false;
        node.getAddress_visited = false;
        node.universe_visited = false;
    return node;
    }
    // Declared in DeviceTree.jadd at line 131


/* Manage Services and connections */

public void wasDisconnected() {
}

    // Declared in DeviceTree.jadd at line 149



/* A Service is aware of its view --- to be obsolete*/

//	private se.lth.cs.sven.PalcomPlug.views.ServiceDescriptionView ServiceDescription.myView;
// Hack to avoid circular dependencies between eclipse projects.
//	private Object Service.myView;
	
	private Connection myConnection;

    // Declared in DeviceTree.jadd at line 151
		// should be a set
	
	public void setConnection(Connection c) {
		myConnection = c;
	}

    // Declared in DeviceTree.jadd at line 155

	
	public Connection getConnection() {
		return myConnection;
	}

    // Declared in DeviceTree.jadd at line 159


	public void setView(Object v) {
		if(myConnection != null) {
			myConnection.setView(v);
		}
//		myView = v;
	}

    // Declared in DeviceTree.jadd at line 166

	
	public Object getView() {
		if(myConnection != null) {
			return myConnection.getView();
		} else {
			return null;
		}
//		return myView;
	}

    // Declared in DeviceTree.jadd at line 271


   public Object[] getChildArray() {
   	return new Object[] {};
//   		if(getNumService() > 0) {
//	   		Object tmp[] = new Object[getNumService()];
//			for(int i=0; i<getNumService(); i++) {
//				tmp[i] = getService(i);
//			}
//			return tmp;
//		} else {
//			return null;
//		}
   }

    // Declared in DeviceTree.jadd at line 368

   
	public String toString() {
   		return "Service: "+getInfo().toString();
	}

    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 46

    public Service() {
        super();

        setChild(null, 0);

    }

    // Declared in LocalView.ast at line 11


    // Declared in LocalView.ast line 46
    public Service(ServiceInfo p0) {
        setChild(p0, 0);
    }

    // Declared in LocalView.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in LocalView.ast at line 2
    // Declared in LocalView.ast line 46
    public void setInfo(ServiceInfo node) {
        setChild(node, 0);
    }

    // Declared in LocalView.ast at line 5

    public ServiceInfo getInfo() {
        return (ServiceInfo)getChild(0);
    }

    // Declared in LocalView.ast at line 9


    public ServiceInfo getInfoNoTransform() {
        return (ServiceInfo)getChildNoTransform(0);
    }

    protected boolean getServiceInfoListItem_visited = false;
    // Declared in DeviceTree.jadd at line 126
    public ServiceInfoListItem getServiceInfoListItem() {
        if(getServiceInfoListItem_visited)
            throw new RuntimeException("Circular definition of attr: getServiceInfoListItem in class: ");
        getServiceInfoListItem_visited = true;
        ServiceInfoListItem getServiceInfoListItem_value = getServiceInfoListItem_compute();
        getServiceInfoListItem_visited = false;
        return getServiceInfoListItem_value;
    }

    private ServiceInfoListItem getServiceInfoListItem_compute() {  return  getInfo();  }

    protected boolean getBrowserLabel_visited = false;
    // Declared in LabelProviders.jrag at line 65
    public String getBrowserLabel() {
        if(getBrowserLabel_visited)
            throw new RuntimeException("Circular definition of attr: getBrowserLabel in class: ");
        getBrowserLabel_visited = true;
        String getBrowserLabel_value = getBrowserLabel_compute();
        getBrowserLabel_visited = false;
        return getBrowserLabel_value;
    }

    private String getBrowserLabel_compute() {  return  getInfo().getName() + " : " + getStatus();  }

    protected java.util.Set localLookup_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 111
    public NetworkNode localLookup(Object o) {
        Object _parameters = o;
        if(localLookup_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: localLookup in class: ");
        localLookup_Object_visited.add(_parameters);
        NetworkNode localLookup_Object_value = localLookup_compute(o);
        localLookup_Object_visited.remove(_parameters);
        return localLookup_Object_value;
    }

    private NetworkNode localLookup_compute(Object o)  {
	synchronized(universe()) {

		if(matches(o)) {
			return this;
		} else { 
			return null;	
		}
	}
}

    protected java.util.Set isResource_AbstractResourceAddress_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 124
    public boolean isResource(AbstractResourceAddress a) {
        Object _parameters = a;
        if(isResource_AbstractResourceAddress_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: isResource in class: ");
        isResource_AbstractResourceAddress_visited.add(_parameters);
        boolean isResource_AbstractResourceAddress_value = isResource_compute(a);
        isResource_AbstractResourceAddress_visited.remove(_parameters);
        return isResource_AbstractResourceAddress_value;
    }

    private boolean isResource_compute(AbstractResourceAddress a) {  return  getAddress().equals(a);  }

    protected java.util.Set matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 128
    public boolean matchesLocalSID(LocalSID l) {
        Object _parameters = l;
        if(matchesLocalSID_LocalSID_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesLocalSID in class: ");
        matchesLocalSID_LocalSID_visited.add(_parameters);
        boolean matchesLocalSID_LocalSID_value = matchesLocalSID_compute(l);
        matchesLocalSID_LocalSID_visited.remove(_parameters);
        return matchesLocalSID_LocalSID_value;
    }

    private boolean matchesLocalSID_compute(LocalSID l) {  return  getAddress().matchesLocalSID(l);  }

    protected java.util.Set matchesInfo_Info_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 137
    public boolean matchesInfo(Info i) {
        Object _parameters = i;
        if(matchesInfo_Info_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesInfo in class: ");
        matchesInfo_Info_visited.add(_parameters);
        boolean matchesInfo_Info_value = matchesInfo_compute(i);
        matchesInfo_Info_visited.remove(_parameters);
        return matchesInfo_Info_value;
    }

    private boolean matchesInfo_compute(Info i) {  return  isResource(i.getAddress());  }

    protected boolean getName_visited = false;
    // Declared in NameAnalysis.jrag at line 171
    public String getName() {
        if(getName_visited)
            throw new RuntimeException("Circular definition of attr: getName in class: ");
        getName_visited = true;
        String getName_value = getName_compute();
        getName_visited = false;
        return getName_value;
    }

    private String getName_compute()  {
	if(getInfo() != null) return getInfo().getName();
	return null;
}

    protected boolean getAddress_visited = false;
    // Declared in NameAnalysis.jrag at line 177
    public ServiceAddress getAddress() {
        if(getAddress_visited)
            throw new RuntimeException("Circular definition of attr: getAddress in class: ");
        getAddress_visited = true;
        ServiceAddress getAddress_value = getAddress_compute();
        getAddress_visited = false;
        return getAddress_value;
    }

    private ServiceAddress getAddress_compute()  {
	if(getInfo() instanceof ServiceInfo) return ((ServiceInfo)getInfo()).getServiceAddress();
	return null;
}

    protected boolean universe_visited = false;
    // Declared in NameAnalysis.jrag at line 44
    public Universe universe() {
        if(universe_visited)
            throw new RuntimeException("Circular definition of attr: universe in class: ");
        universe_visited = true;
        Universe universe_value = getParent().Define_Universe_universe(this, null);
        universe_visited = false;
        return universe_value;
    }

}
