/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ServiceInfo extends ServiceInfoListItem implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getAddress_visited = false;
        toString_visited = false;
        hasDesc_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceInfo node = (ServiceInfo)super.clone();
        node.getAddress_visited = false;
        node.toString_visited = false;
        node.hasDesc_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ServiceInfo node = (ServiceInfo)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ServiceInfo res = (ServiceInfo)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in DeviceTree.jadd at line 64


public ServiceListPart createServiceNode() {
	Service tmps;
//	if(ServiceProxy.CONTENT_TYPE.equals(getContentType())) {
//	//XXX This is a hack, the proper way is like the commented out part below
//		if(getName().equals(SelfTestProvider.SERVICE_NAME)) {
//			tmps = new SelfTestService();
//		} else {
			tmps = new ControlService();
//		}
//	} else if (SelfTestProvider.CONTENT_TYPE.equals(getContentType())) {
//		tmps = new SelfTestService();
//	} else {
//		tmps = new StreamingService();
//	}
	tmps.setInfo(this);
	return tmps;	
}

    // Declared in Comparison.jadd at line 3


	public boolean equals(Object o) {
		if(o instanceof ServiceInfo) {
			return ((ServiceInfo)o).getAddress().equals(getAddress());
		} else {
			return super.equals(o);
		}
	}

    // Declared in HLAXML.jadd at line 86

	
	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
      	serializer.startTag(null, getTagName());
      	serializer.attribute(null, "name", getName());
		getServiceAddress().writeXMLElement(serializer);
		serializer.endTag(null, getTagName());
	}

    // Declared in HLAXML.jadd at line 93


	public void initializeFromElement(XmlPullParser parser) {
		setName(parser.getAttributeValue(null, "name"));
    }

    // Declared in HLAXML.jadd at line 97


	public void addChildFromXMLElement(XMLRepresentable child) {
		setServiceAddress((ServiceAddress)child);
	}

    // Declared in roleFix.jadd at line 2

	public boolean isCustomer() {
		throw new Error("ServiceInfo.isCustomer() not implemented");
	}

    // Declared in roleFix.jadd at line 6

	
	public boolean isProvider() {
		throw new Error("ServiceInfo.isProvider() not implemented");
	}

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 50

    public ServiceInfo() {
        super();

        setChild(null, 0);

    }

    // Declared in HighLevelResourceInfo.ast at line 11


    // Declared in HighLevelResourceInfo.ast line 50
    public ServiceInfo(ServiceAddress p0, String p1) {
        setChild(p0, 0);
        setName(p1);
    }

    // Declared in HighLevelResourceInfo.ast at line 16


  protected int numChildren() {
    return 1;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 50
    public void setServiceAddress(ServiceAddress node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public ServiceAddress getServiceAddress() {
        return (ServiceAddress)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public ServiceAddress getServiceAddressNoTransform() {
        return (ServiceAddress)getChildNoTransform(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 50
    private String tokenString_Name;

    // Declared in HighLevelResourceInfo.ast at line 3

    public void setName(String value) {
        tokenString_Name = value;
    }

    // Declared in HighLevelResourceInfo.ast at line 6

    public String getName() {
        return tokenString_Name;
    }

    protected boolean getAddress_visited = false;
    // Declared in Address.jadd at line 10
    public AbstractResourceAddress getAddress() {
        if(getAddress_visited)
            throw new RuntimeException("Circular definition of attr: getAddress in class: ");
        getAddress_visited = true;
        AbstractResourceAddress getAddress_value = getAddress_compute();
        getAddress_visited = false;
        return getAddress_value;
    }

    private AbstractResourceAddress getAddress_compute()  {
		return getServiceAddress();
	}

    protected boolean toString_visited = false;
    // Declared in displayStrings.jadd at line 5
    public String toString() {
        if(toString_visited)
            throw new RuntimeException("Circular definition of attr: toString in class: ");
        toString_visited = true;
        String toString_value = toString_compute();
        toString_visited = false;
        return toString_value;
    }

    private String toString_compute() {  return  "ServiceInfo: "+getServiceAddress().toString();  }

    protected boolean hasDesc_visited = false;
    // Declared in roleFix.jadd at line 10
    public boolean hasDesc() {
        if(hasDesc_visited)
            throw new RuntimeException("Circular definition of attr: hasDesc in class: ");
        hasDesc_visited = true;
        boolean hasDesc_value = hasDesc_compute();
        hasDesc_visited = false;
        return hasDesc_value;
    }

    private boolean hasDesc_compute() {  return getServiceAddress().getPRDService().getHasDesc();  }

}
