/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;



public abstract class ServiceListPart extends NetworkNode implements Cloneable {
    public void flushCache() {
        super.flushCache();
        matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        matches_Object_visited = new java.util.HashSet(4);
        parentDevice_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceListPart node = (ServiceListPart)super.clone();
        node.matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        node.matches_Object_visited = new java.util.HashSet(4);
        node.parentDevice_visited = false;
    return node;
    }
    // Declared in LocalView.ast at line 3
    // Declared in LocalView.ast line 45

    public ServiceListPart() {
        super();


    }

    // Declared in LocalView.ast at line 9


  protected int numChildren() {
    return 0;
  }

    // Declared in DeviceTree.jadd at line 124
    public abstract ServiceInfoListItem getServiceInfoListItem();
    // Declared in NameAnalysis.jrag at line 88
    public abstract NetworkNode localLookup(Object o);
    protected java.util.Set matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 127
    public boolean matchesLocalSID(LocalSID l) {
        Object _parameters = l;
        if(matchesLocalSID_LocalSID_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesLocalSID in class: ");
        matchesLocalSID_LocalSID_visited.add(_parameters);
        boolean matchesLocalSID_LocalSID_value = matchesLocalSID_compute(l);
        matchesLocalSID_LocalSID_visited.remove(_parameters);
        return matchesLocalSID_LocalSID_value;
    }

    private boolean matchesLocalSID_compute(LocalSID l) {  return  false;  }

    protected java.util.Set matches_Object_visited = new java.util.HashSet(4);
    // Declared in NameAnalysis.jrag at line 150
    public boolean matches(Object o) {
        Object _parameters = o;
        if(matches_Object_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matches in class: ");
        matches_Object_visited.add(_parameters);
        boolean matches_Object_value = matches_compute(o);
        matches_Object_visited.remove(_parameters);
        return matches_Object_value;
    }

    private boolean matches_compute(Object o)  {
	if(o instanceof AbstractResourceAddress)
		return isResource((AbstractResourceAddress)o);
	else if(o instanceof LocalSID)
		return matchesLocalSID((LocalSID)o);
	else if(o instanceof Info)
		return matchesInfo((Info)o);

//	System.out.println("Service does not match "+o);
	return false;
}

    protected boolean parentDevice_visited = false;
    // Declared in DeviceTree.jadd at line 86
    public Device parentDevice() {
        if(parentDevice_visited)
            throw new RuntimeException("Circular definition of attr: parentDevice in class: ");
        parentDevice_visited = true;
        Device parentDevice_value = getParent().Define_Device_parentDevice(this, null);
        parentDevice_visited = false;
        return parentDevice_value;
    }

}
