/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ServiceUse extends ServiceExp implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getDecl_visited = false;
        matches_Identifier_visited = new java.util.HashSet(4);
        getErrorList_visited = false;
        getAssemblyLabel_visited = false;
        getLocalSID_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ServiceUse node = (ServiceUse)super.clone();
        node.getDecl_visited = false;
        node.matches_Identifier_visited = new java.util.HashSet(4);
        node.getErrorList_visited = false;
        node.getAssemblyLabel_visited = false;
        node.getLocalSID_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ServiceUse node = (ServiceUse)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ServiceUse res = (ServiceUse)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyScript.jadd at line 114

	
	public AbstractResourceAddress getServiceAddress() {
		ServiceDecl d = av().lookupService(getIdentifier());
		if(d != null && d.getDecl() instanceof SingleServiceDecl) 
			return ((SingleServiceDecl)d.getDecl()).getServiceAddress();
		else {
			System.err.println("WARNING! ServiceUse.getServiceAddress() returning null for unknown service "+getIdentifier().getID());
			return null; //new URN("UNKNOWN SERVICE ("+getIdentifier().getID()+")");
		}
	}

    // Declared in AssemblyScript.jadd at line 236

	
	public String toString() {
		return getIdentifier().getID();
	}

    // Declared in AssemblyXML.jadd at line 276

    public String getTagName() {
    	return "ServiceUse";
    }

    // Declared in AssemblyXML.jadd at line 295


    public void writeXMLElement(KXmlSerializer serializer)
    throws IOException {
        serializer.startTag(null, getTagName());
        getIdentifier().writeXMLElement(serializer);
        serializer.endTag(null, getTagName());
    }

    // Declared in AssemblyXML.jadd at line 302

    
    public void initializeFromElement(XmlPullParser parser) {
    }

    // Declared in AssemblyXML.jadd at line 305

        
    public void addChildFromXMLElement(XMLRepresentable child) {
        setIdentifier((Identifier) child);
    }

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 64

    public ServiceUse() {
        super();

        setChild(null, 0);

    }

    // Declared in Assembly.ast at line 11


    // Declared in Assembly.ast line 64
    public ServiceUse(Identifier p0) {
        setChild(p0, 0);
    }

    // Declared in Assembly.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in Assembly.ast at line 2
    // Declared in Assembly.ast line 64
    public void setIdentifier(Identifier node) {
        setChild(node, 0);
    }

    // Declared in Assembly.ast at line 5

    public Identifier getIdentifier() {
        return (Identifier)getChild(0);
    }

    // Declared in Assembly.ast at line 9


    public Identifier getIdentifierNoTransform() {
        return (Identifier)getChildNoTransform(0);
    }

    protected boolean getDecl_visited = false;
    // Declared in AssemblyNameAnalysis.jrag at line 293
    public ServiceDecl getDecl() {
        if(getDecl_visited)
            throw new RuntimeException("Circular definition of attr: getDecl in class: ");
        getDecl_visited = true;
        ServiceDecl getDecl_value = getDecl_compute();
        getDecl_visited = false;
        return getDecl_value;
    }

    private ServiceDecl getDecl_compute() {  return  av().lookupService(getIdentifier());  }

    protected java.util.Set matches_Identifier_visited = new java.util.HashSet(4);
    // Declared in AssemblyNameAnalysis.jrag at line 372
    public boolean matches(Identifier id) {
        Object _parameters = id;
        if(matches_Identifier_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matches in class: ");
        matches_Identifier_visited.add(_parameters);
        boolean matches_Identifier_value = matches_compute(id);
        matches_Identifier_visited.remove(_parameters);
        return matches_Identifier_value;
    }

    private boolean matches_compute(Identifier id) {  return  getIdentifier().equals(id);  }

    protected boolean getErrorList_visited = false;
    // Declared in ErrorChecking.jrag at line 83
    public ArrayList getErrorList() {
        if(getErrorList_visited)
            throw new RuntimeException("Circular definition of attr: getErrorList in class: ");
        getErrorList_visited = true;
        ArrayList getErrorList_value = getErrorList_compute();
        getErrorList_visited = false;
        return getErrorList_value;
    }

    private ArrayList getErrorList_compute()  {
		ArrayList l = new ArrayList();
		ServiceDecl d = av().lookupService(getIdentifier());
		if(d == null) 
			l.add(l.size(),new SemanticError(SemanticError.TYPE_ERROR,"Unknown service "+getIdentifier().getID(), this));
		return l;
	}

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 183
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  getIdentifier().getAssemblyLabel();  }

    protected boolean getLocalSID_visited = false;
    // Declared in LocalSID.jadd at line 4
    public LocalSID getLocalSID() {
        if(getLocalSID_visited)
            throw new RuntimeException("Circular definition of attr: getLocalSID in class: ");
        getLocalSID_visited = true;
        LocalSID getLocalSID_value = getLocalSID_compute();
        getLocalSID_visited = false;
        return getLocalSID_value;
    }

    private LocalSID getLocalSID_compute()  {
	    	  ServiceAddress sa = getDecl().getServiceAddr();
	    	//  if(sa.hasPRDService()) return sa.getPRDService().getLocalSID();
	    	  if(sa.hasLocalSID()) return sa.getLocalSID();
	    	  return null;
	 }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 62
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
