/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class TemporaryAddress extends AbstractResourceAddress implements Cloneable {
    public void flushCache() {
        super.flushCache();
        tryGetLocalSID_visited = false;
        getDeviceAddress_visited = false;
        matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        toString_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        TemporaryAddress node = (TemporaryAddress)super.clone();
        node.tryGetLocalSID_visited = false;
        node.getDeviceAddress_visited = false;
        node.matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
        node.toString_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          TemporaryAddress node = (TemporaryAddress)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        TemporaryAddress res = (TemporaryAddress)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in Comparison.jadd at line 87

    
    public boolean equals(Object o) {
    	if(o instanceof TemporaryAddress) {
    		return getLocalSID().equals(((TemporaryAddress)o).getLocalSID());
    	} else if (o instanceof ServiceAddress) {
    		return ( ((ServiceAddress)o).matchesLocalSID(getLocalSID()));
    	} else {
    		return super.equals(o);
    	}
    }

    // Declared in HLAXML.jadd at line 76

	
	
	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
      	serializer.startTag(null, getTagName());
		getLocalSID().writeXMLElement(serializer);
		serializer.endTag(null, getTagName());
	}

    // Declared in HLAXML.jadd at line 82


	public void addChildFromXMLElement(XMLRepresentable child) {
		setLocalSID((LocalSID)child);
	}

    // Declared in HighLevelResourceInfo.ast at line 3
    // Declared in HighLevelResourceInfo.ast line 42

    public TemporaryAddress() {
        super();

        setChild(null, 0);

    }

    // Declared in HighLevelResourceInfo.ast at line 11


    // Declared in HighLevelResourceInfo.ast line 42
    public TemporaryAddress(LocalSID p0) {
        setChild(p0, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 15


  protected int numChildren() {
    return 1;
  }

    // Declared in HighLevelResourceInfo.ast at line 2
    // Declared in HighLevelResourceInfo.ast line 42
    public void setLocalSID(LocalSID node) {
        setChild(node, 0);
    }

    // Declared in HighLevelResourceInfo.ast at line 5

    public LocalSID getLocalSID() {
        return (LocalSID)getChild(0);
    }

    // Declared in HighLevelResourceInfo.ast at line 9


    public LocalSID getLocalSIDNoTransform() {
        return (LocalSID)getChildNoTransform(0);
    }

    protected boolean tryGetLocalSID_visited = false;
    // Declared in LocalSID.jadd at line 31
    public LocalSID tryGetLocalSID() {
        if(tryGetLocalSID_visited)
            throw new RuntimeException("Circular definition of attr: tryGetLocalSID in class: ");
        tryGetLocalSID_visited = true;
        LocalSID tryGetLocalSID_value = tryGetLocalSID_compute();
        tryGetLocalSID_visited = false;
        return tryGetLocalSID_value;
    }

    private LocalSID tryGetLocalSID_compute() {  return  getLocalSID();  }

    protected boolean getDeviceAddress_visited = false;
    // Declared in Address.jadd at line 69
    public DeviceAddress getDeviceAddress() {
        if(getDeviceAddress_visited)
            throw new RuntimeException("Circular definition of attr: getDeviceAddress in class: ");
        getDeviceAddress_visited = true;
        DeviceAddress getDeviceAddress_value = getDeviceAddress_compute();
        getDeviceAddress_visited = false;
        return getDeviceAddress_value;
    }

    private DeviceAddress getDeviceAddress_compute() {  return  new DeviceAddress(getLocalSID().getDeviceID());  }

    protected java.util.Set matchesLocalSID_LocalSID_visited = new java.util.HashSet(4);
    // Declared in Comparison.jadd at line 99
    public boolean matchesLocalSID(LocalSID l) {
        Object _parameters = l;
        if(matchesLocalSID_LocalSID_visited.contains(_parameters))
            throw new RuntimeException("Circular definition of attr: matchesLocalSID in class: ");
        matchesLocalSID_LocalSID_visited.add(_parameters);
        boolean matchesLocalSID_LocalSID_value = matchesLocalSID_compute(l);
        matchesLocalSID_LocalSID_visited.remove(_parameters);
        return matchesLocalSID_LocalSID_value;
    }

    private boolean matchesLocalSID_compute(LocalSID l) {  return 
		getLocalSID().equals(l);  }

    protected boolean toString_visited = false;
    // Declared in displayStrings.jadd at line 19
    public String toString() {
        if(toString_visited)
            throw new RuntimeException("Circular definition of attr: toString in class: ");
        toString_visited = true;
        String toString_value = toString_compute();
        toString_visited = false;
        return toString_value;
    }

    private String toString_compute() {  return  "TA:"+getLocalSID().toString();  }

}
