/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ist.palcom.resource.descriptor;
import ist.palcom.resourceAddressing.ResourceAddressingManager;import ist.palcom.debugging.DebugDispatcher;import ist.palcom.device.DeviceContext;import ist.palcom.services.SelfTestProvider;import ist.palcom.assemblies.SemanticError;import java.lang.Object;import ist.palcom.assemblies.Assembly;import java.util.ArrayList;import java.util.Iterator;import java.io.PrintStream;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import java.util.ArrayList;import ist.palcom.mal.Message;import ist.palcom.mal.MultiPartMessage;import ist.palcom.mal.SimpleMessage;import ist.palcom.palcomthreads.PalcomThread;import ist.palcom.discovery.CommandEvent;import ist.palcom.hgraph.IHgraphNode;import ist.palcom.hgraph.HgraphNode;import ist.palcom.hgraph.Path;import ist.palcom.hgraph.ValueFunc;import ist.palcom.hgraph.FuncFunc;import ist.palcom.hgraph.SiblingFunc;import java.util.Iterator;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;import ist.palcom.xml.XMLFactory;import java.io.ByteArrayOutputStream;import java.io.IOException;import org.kxml2.io.KXmlSerializer;import ist.palcom.xml.XMLRepresentable;import org.xmlpull.v1.XmlPullParser;


public class ThisService extends ServiceExp implements Cloneable {
    public void flushCache() {
        super.flushCache();
        getAssemblyLabel_visited = false;
        getLocalSID_visited = false;
        custServiceAddress_visited = false;
        av_visited = false;
    }
    public Object clone() throws CloneNotSupportedException {
        ThisService node = (ThisService)super.clone();
        node.getAssemblyLabel_visited = false;
        node.getLocalSID_visited = false;
        node.custServiceAddress_visited = false;
        node.av_visited = false;
    return node;
    }
    public ASTNode copy() {
      try {
          ThisService node = (ThisService)clone();
          if(children != null) node.children = (ASTNode[])children.clone();
          return node;
      } catch (CloneNotSupportedException e) {
      }
      System.err.println("Error: Could not clone node of type " + getClass().getName() + "!");
      return null;
    }
    public ASTNode fullCopy() {
        ThisService res = (ThisService)copy();
        for(int i = 0; i < getNumChild(); i++) {
          ASTNode node = getChildNoTransform(i);
          if(node != null) node = node.fullCopy();
          res.setChild(node, i);
        }
        return res;
    }
    // Declared in AssemblyScript.jadd at line 107

	
//	public void ThisService.setServiceAddress(ServiceAddress sa) {
//		this.sa = sa;
//	}
//	public ServiceAddress ThisService.getServiceAddress() {
//		return sa;
//	}
	public AbstractResourceAddress getServiceAddress() {
		return custServiceAddress();
	}

    // Declared in AssemblyScript.jadd at line 240

	
	public String toString() {
		return "this";
	}

    // Declared in AssemblyXML.jadd at line 350


    
//	public String ServiceOnDevice.getTagName() {
//		return "ServiceOnDevice";
//	}
//
//	public void ServiceOnDevice.writeXMLElement(KXmlSerializer serializer) throws IOException {
//        serializer.startTag(null, getTagName());
//        getServiceUse().writeXMLElement(serializer);
//        getDeviceUse().writeXMLElement(serializer);
////        serializer.attribute(null, "service", getServiceUse().getID());                
////        serializer.attribute(null, "device", getDeviceUse().getID());
//        serializer.endTag(null, getTagName());
//	}
//
//	public void ServiceOnDevice.initializeFromElement(XmlPullParser parser) {
//	}
//
//	public void ServiceOnDevice.addChildFromXMLElement(XMLRepresentable child) {    
//		if(child instanceof ServiceUse) {
//			setServiceUse((ServiceUse)child);
//		}else if(child instanceof DeviceUse) {
//			setDeviceUse((DeviceUse)child);
//		}
//	}
    
	public String getTagName() {
		return "ThisService";
	}

    // Declared in AssemblyXML.jadd at line 354


	public void writeXMLElement(KXmlSerializer serializer) throws IOException {
        serializer.startTag(null, getTagName());
        serializer.endTag(null, getTagName());
	}

    // Declared in AssemblyXML.jadd at line 359


	public void initializeFromElement(XmlPullParser parser) {
	}

    // Declared in Assembly.ast at line 3
    // Declared in Assembly.ast line 65

    public ThisService() {
        super();


    }

    // Declared in Assembly.ast at line 9


  protected int numChildren() {
    return 0;
  }

    protected boolean getAssemblyLabel_visited = false;
    // Declared in LabelProviders.jrag at line 181
    public String getAssemblyLabel() {
        if(getAssemblyLabel_visited)
            throw new RuntimeException("Circular definition of attr: getAssemblyLabel in class: ");
        getAssemblyLabel_visited = true;
        String getAssemblyLabel_value = getAssemblyLabel_compute();
        getAssemblyLabel_visited = false;
        return getAssemblyLabel_value;
    }

    private String getAssemblyLabel_compute() {  return  "this";  }

    protected boolean getLocalSID_visited = false;
    // Declared in LocalSID.jadd at line 11
    public LocalSID getLocalSID() {
        if(getLocalSID_visited)
            throw new RuntimeException("Circular definition of attr: getLocalSID in class: ");
        getLocalSID_visited = true;
        LocalSID getLocalSID_value = getLocalSID_compute();
        getLocalSID_visited = false;
        return getLocalSID_value;
    }

    private LocalSID getLocalSID_compute()  {
	 	System.err.println("ThisService.getLocalSID() not implemented");
		return null;	 
	}

    protected boolean custServiceAddress_visited = false;
    // Declared in AssemblyScript.jadd at line 98
    public AbstractResourceAddress custServiceAddress() {
        if(custServiceAddress_visited)
            throw new RuntimeException("Circular definition of attr: custServiceAddress in class: ");
        custServiceAddress_visited = true;
        AbstractResourceAddress custServiceAddress_value = getParent().Define_AbstractResourceAddress_custServiceAddress(this, null);
        custServiceAddress_visited = false;
        return custServiceAddress_value;
    }

    protected boolean av_visited = false;
    // Declared in AssemblyTree.jadd at line 60
    public PRDAssemblyVer av() {
        if(av_visited)
            throw new RuntimeException("Circular definition of attr: av in class: ");
        av_visited = true;
        PRDAssemblyVer av_value = getParent().Define_PRDAssemblyVer_av(this, null);
        av_visited = false;
        return av_value;
    }

}
