/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ist.palcom.resource.function;

import ist.palcom.resource.communication.CommunicationInfoXMLFactory;
import ist.palcom.resource.descriptor.AssemblyID;
import ist.palcom.resource.descriptor.CommandInfo;
import ist.palcom.resource.descriptor.DeviceID;
import ist.palcom.resource.descriptor.GroupInfo;
import ist.palcom.resource.descriptor.LocalSID;
import ist.palcom.resource.descriptor.PRDConnectionList;
import ist.palcom.resource.descriptor.PRDDevice;
import ist.palcom.resource.descriptor.PRDService;
import ist.palcom.resource.descriptor.PRDServiceFMDescription;
import ist.palcom.resource.descriptor.PRDServiceList;
import ist.palcom.resource.descriptor.PRDSubList;
import ist.palcom.resource.descriptor.ParamInfo;
import ist.palcom.resource.descriptor.ServiceID;
import ist.palcom.resource.descriptor.ServiceInstanceID;
import ist.palcom.resource.descriptor.VersionPart;
import ist.palcom.xml.XMLException;
import ist.palcom.xml.XMLRepresentable;

public class FunctionInfoXMLFactory extends CommunicationInfoXMLFactory{

	protected XMLRepresentable createFromTagName(String tagName) throws XMLException {
		if (tagName.equals("D")) {
			return new PRDDevice();
		} else if (tagName.equals("S")) {
			return new PRDService();
		} else if (tagName.equals("SL")) {
			return new PRDServiceList();
		} else if (tagName.equals("SubL")) {
				return new PRDSubList();
		} else if (tagName.equals("SIID")) {
			return new ServiceInstanceID();
		} else if (tagName.equals("SID")) {
			return new ServiceID();
		} else if (tagName.equals("LocalSID")) {
			return new LocalSID();
		} else if (tagName.equals("DID")) {
			return new DeviceID();
		} else if (tagName.equals("VP")) {
				return new VersionPart();
		} else if (tagName.equals("CL")) {
			return new PRDConnectionList();
		} else if (tagName.equals("SD")) {
			return new PRDServiceFMDescription();
		} else if (tagName.equals("GI")) {
			return new GroupInfo();
		} else if (tagName.equals("CmdI")) {
			return new CommandInfo();
		} else if (tagName.equals("PI")) {
			return new ParamInfo();
		} else if (tagName.equals("AID")) {
			return new AssemblyID();
		} else {
			return super.createFromTagName(tagName);
		}
	}
}
