/*
   Copyright (c) 2004-2007, The PalCom Project consortium.
   See http://www.ist-palcom.org/consortium.

   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are
   met:

       * Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

       * Redistributions in binary form must reproduce the above
         copyright notice, this list of conditions and the following
         disclaimer in the documentation and/or other materials provided
         with the distribution.

       * Neither the name of the PalCom Project nor the names of its
         contributors may be used to endorse or promote products derived
         from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ist.palcom.routing;

import ist.palcom.hgraph.IHgraphNode;
import ist.palcom.mal.Message;
import ist.palcom.palcomthreads.PalcomThread;
import ist.palcom.resource.descriptor.Selector;
import ist.palcom.resource.descriptor.URN;

public interface RoutingManager extends IHgraphNode{

//	public URL[] getDefaultGroupAddresses();
//	public void stopReceiving(URL url, PalcomThread receiver);
//	public URL startReceiving(URL url, PalcomThread receiver);	
	public void stopReceiving(PalcomThread receiver);
//	public URL startReceiving(PalcomThread receiver);
//	public Selector startReceiving2(PalcomThread receiver);
	public void stopReceiving(Selector selector);
//	public void stopReceiving(URL url);
//	public void send(Message msg, URL url);
	public boolean send(Message msg, URN urn1, Selector selector1, URN urn2, Selector selector2);
	
	//The following methods supports the new wire protocol
	public boolean send(Message message, String receiverDeviceID);
	public void stop();
	public void addErrorHandler(PalcomThread handler);
	public void setLocalDeviceCache(String localDeviceCache);
	public String getLocalDeviceCache();
	public void setLocalDeviceID(String localDeviceID);
	public void setLocalStatusFlag(byte statusFlag);
	public void setLocalDiscoveryVersion(String discoveryVersion);
	public void setDiscoverySelector(Selector selector);
	public void sendBroadcast(Message message);
	public void sendHeartAttack();
	public void registerAsListener(PalcomThread communicationManager);
	public void registerForHeartBeats(PalcomThread resourceManager);
	public void sendHeartBeat(boolean isHeartBeatAck);
	public void unregisterDevice(String deviceID);
}
